using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace WindowsApplication24
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.Location = new System.Drawing.Point(8, 8);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(592, 312);
			this.dataGrid1.TabIndex = 0;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(136, 328);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(120, 32);
			this.button1.TabIndex = 1;
			this.button1.Text = "Load from XML";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(264, 328);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(120, 32);
			this.button2.TabIndex = 2;
			this.button2.Text = "Update";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(392, 328);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(120, 32);
			this.button3.TabIndex = 3;
			this.button3.Text = "Save to XML";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(8, 328);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(120, 32);
			this.button4.TabIndex = 4;
			this.button4.Text = "SQL Server Load";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 368);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(592, 40);
			this.label1.TabIndex = 5;
			this.label1.Text = @"This demo splits the Appendix A ""Example Updating Explicit Row and Column"" code into three parts -- loading a dataset from XML, updating the dataset, and saving the XML (to a different file). We can also choose to load the data from SQL Server instead of XML.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 413);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button4,
																		  this.button3,
																		  this.button2,
																		  this.button1,
																		  this.dataGrid1});
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			String loadName = Application.StartupPath + "\\original.xml";
			DataSet ds = new DataSet();
			ds.ReadXml(loadName, XmlReadMode.Auto);
			dataGrid1.DataSource = ds;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			DataSet ds = (DataSet)dataGrid1.DataSource;
			DataTable tableRow; // Table named 'row' found in xml
			DataColumn colCompanyName, //
				colPhone;
			DataRow [] rows; // results of DataSet.Select returned here
			// FOR XML RAW produces a set of rows named "row" so table is called "row"
			tableRow = ds.Tables["row"];

			/// In order to increase the performance of data change
			/// methods, BeginLoadData, turns off notifications, 
			/// index maintenance, and constraints enforcement.
			/// In database terms compare this to bulk load or not adding
			/// a table's indexes until after all the data is added. 
			tableRow.BeginLoadData();

			colPhone = tableRow.Columns["Phone"];

			// search for all rows with ShipperID='2'
			rows = tableRow.Select("ShipperID='2'");
			rows[0][colPhone] = "(800) 555 1234";

			colCompanyName = tableRow.Columns["CompanyName"];            

			// Search for all rows with CompanyName='Federal Shipping'
			rows = tableRow.Select("CompanyName='Federal Shipping'");

			rows[0][colCompanyName] = "More Most Fasterest Delivery";

			tableRow.EndLoadData();


		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			String saveName = Application.StartupPath + "\\updated.xml";
			DataSet ds = (DataSet)dataGrid1.DataSource;
			DialogResult diagResult;

			diagResult =
				MessageBox.Show("Accept Changes (yes) or Reject Changes (no)?", 
				"Ch-Ch-Changes", 
				MessageBoxButtons.YesNo);
			if (DialogResult.Yes == diagResult)
			{
				ds.AcceptChanges();
				ds.WriteXml(saveName, XmlWriteMode.WriteSchema);
			}

			else // if (DialogResult.No == diagResult)
			{
				ds.RejectChanges();
			}

		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			String SQL_CONN = "Data Source=localhost;Initial Catalog=Northwind;User ID=sa;";
			String SQL_COMM = "Select * From Shippers";
			SqlConnection conn = new SqlConnection(SQL_CONN);
			SqlCommand comm = new SqlCommand(SQL_COMM, conn);
			conn.Open();
			SqlDataAdapter ad = new SqlDataAdapter(comm);
			DataSet ds = new DataSet();
			ad.Fill( ds, "row");
			dataGrid1.DataSource = ds;
		}
	}
}
