using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace WindowsApplication20
{
	

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		const string SQL_CONNECTION = "Data Source=localhost;Initial Catalog=Northwind;User ID=sa;";
		const string SQL_COMMAND = "SELECT * FROM Customers";

		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button btnCheckErrors;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		static void WXShowPerTableErrors(DataTable table)
		{
			if (table.HasErrors)
			{
				int index = 1;

				Console.WriteLine("Table with Error(s): {0}",
					table.TableName);
				foreach (DataRow row in table.GetErrors())
				{
					Console.WriteLine("Row in error {0}", index);
					index++;
					foreach(DataColumn column in table.Columns)
					{
						Console.WriteLine("Column in Error: {0}, Error: {1}",
							column.ColumnName,
							row.GetColumnError(column));
					}

					row.ClearErrors();
				}
			}

			else
			{
				Console.WriteLine("Table without Error(s): {0}",
					table.TableName);
			}
		}

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnCheckErrors = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// btnCheckErrors
			// 
			this.btnCheckErrors.Location = new System.Drawing.Point(104, 408);
			this.btnCheckErrors.Name = "btnCheckErrors";
			this.btnCheckErrors.Size = new System.Drawing.Size(88, 32);
			this.btnCheckErrors.TabIndex = 2;
			this.btnCheckErrors.Text = "Show Errors";
			this.btnCheckErrors.Click += new System.EventHandler(this.btnCheckErrors_Click);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 408);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 32);
			this.button1.TabIndex = 1;
			this.button1.Text = "Merge XML";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(416, 400);
			this.dataGrid1.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(416, 445);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnCheckErrors,
																		  this.button1,
																		  this.dataGrid1});
			this.Name = "Form1";
			this.Text = "Merge Demos";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			SqlConnection sqlConn = new SqlConnection(SQL_CONNECTION);
			SqlCommand sqlCmd = new SqlCommand(SQL_COMMAND, sqlConn);
			SqlDataAdapter sqlAdapt;
			DataSet ds = new DataSet("Customers");
			sqlConn.Open();
			sqlAdapt = new SqlDataAdapter(sqlCmd);
            sqlAdapt.Fill(ds, "Customers");
			dataGrid1.DataSource = ds;
			sqlConn.Close();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			DataSet dsOrg;
			dsOrg = (DataSet)dataGrid1.DataSource;
			DataSet dsToMerge = new DataSet();
			MessageBox.Show(Application.StartupPath);
			dsToMerge.ReadXml(Application.StartupPath + "\\xmldata.xml", XmlReadMode.Auto);
			dsOrg.Merge(dsToMerge);
			dataGrid1.DataSource = dsOrg;
		}

		private void btnCheckErrors_Click(object sender, System.EventArgs e)
		{
			DataSet ds = (DataSet)dataGrid1.DataSource;
			DataTable dt = ds.Tables["Customers"];
			WXShowPerTableErrors(dt);
		}
	}
}