using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace csEventsInfoState
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button m_btnConnect;
		private System.Windows.Forms.Button m_btnDisconnect;
		private System.Data.SqlClient.SqlConnection m_sqlConn;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_btnConnect = new System.Windows.Forms.Button();
			this.m_btnDisconnect = new System.Windows.Forms.Button();
			this.m_sqlConn = new System.Data.SqlClient.SqlConnection();
			this.SuspendLayout();
			// 
			// m_btnConnect
			// 
			this.m_btnConnect.Location = new System.Drawing.Point(8, 8);
			this.m_btnConnect.Name = "m_btnConnect";
			this.m_btnConnect.TabIndex = 0;
			this.m_btnConnect.Text = "Connect";
			this.m_btnConnect.Click += new System.EventHandler(this.m_btnConnect_Click);
			// 
			// m_btnDisconnect
			// 
			this.m_btnDisconnect.Location = new System.Drawing.Point(88, 8);
			this.m_btnDisconnect.Name = "m_btnDisconnect";
			this.m_btnDisconnect.TabIndex = 1;
			this.m_btnDisconnect.Text = "Disconnect";
			this.m_btnDisconnect.Click += new System.EventHandler(this.m_btnDisconnect_Click);
			// 
			// m_sqlConn
			// 
			this.m_sqlConn.InfoMessage += new System.Data.SqlClient.SqlInfoMessageEventHandler(this.m_sqlConn_InfoMessage);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(176, 37);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.m_btnDisconnect,
																		  this.m_btnConnect});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		// Setup the initial button states and event handlers
		private void Form1_Load(object sender, System.EventArgs e)
		{
			m_sqlConn = new SqlConnection(	"data source=localhost;"+
											"initial catalog=Northwind;"+
											"integrated security=SSPI;" );
			m_sqlConn.StateChange += new StateChangeEventHandler(OnStateChangeEvent);
			m_btnDisconnect.Enabled = false;
		}
		
		// The Connect button should disable and call Open() request
		private void m_btnConnect_Click(object sender, System.EventArgs e)
		{
			m_btnConnect.Enabled = false;
			try
			{
				m_sqlConn.Open();
			}
			catch(Exception ex )
			{
				MessageBox.Show( ex.Message, "Open Error" );
				m_btnConnect.Enabled = true;
			}
		}

		// The Disconnect button should disable and call Close()
		private void m_btnDisconnect_Click(object sender, System.EventArgs e)
		{
			m_btnDisconnect.Enabled = false;
			m_sqlConn.Close();
		}

		// Event handler to recieve notification of change in connection state
		private void OnStateChangeEvent( object sender, StateChangeEventArgs e )
		{
			MessageBox.Show(e.CurrentState.ToString());
			if( e.CurrentState == ConnectionState.Closed )
				m_btnConnect.Enabled = true;
			if( e.CurrentState == ConnectionState.Open )
				m_btnDisconnect.Enabled = true;
		}

		// InfoMessage event handler to display the Errors
		private void m_sqlConn_InfoMessage(object sender, SqlInfoMessageEventArgs e)
		{
			foreach( SqlError error in e.Errors )
				MessageBox.Show( error.Message,  error.Server );
		}

	}
}
