Module Module1

    Private Sub FindDuplicate(ByVal source As DataSet, ByVal dest As DataSet)
        Dim r() As DataRow
        Dim i As Integer

        For i = 0 To dest.Tables(0).Rows.Count - 1
            r = source.Tables(0).Select("au_id='" & dest.Tables(0).Rows(i)("au_id") & "'")
            If r.Length > 0 Then
                dest.Tables(0).Rows(i).RowError = "Error, duplicate primary key value"
            End If
        Next
    End Sub

    Sub PrintErrors(ByVal d As DataSet)
        Dim i As Integer
        For i = 0 To d.Tables(0).Rows.Count - 1
            If d.Tables(0).Rows(i).HasErrors Then
                Console.WriteLine(d.Tables(0).Rows(i).RowError.ToString())
            End If
        Next
    End Sub

    Sub Main()
        ' Read XML Schema containing table structure.
        Dim ds As New DataSet("DS")
        ds.ReadXmlSchema("C:\AuthorsSchema.XML")

        ' Add a unique constraint on the au_id column
        ds.Tables(0).Constraints.Add("ConstraintID", ds.Tables(0).Columns("au_id"), True)

        ' Add the first record
        Dim dr As DataRow = ds.Tables(0).NewRow()
        dr("au_id") = "222-22-2222"
        dr("au_fname") = "Fabio Claudio"
        dr("au_lname") = "Ferracchiati"
        dr("contract") = True
        ds.Tables(0).Rows.Add(dr)
        ds.Tables(0).AcceptChanges()

        ' Another DataSet filled with XML data
        Dim dsXML As New DataSet("XMLDataSet")
        dsXML.ReadXmlSchema("C:\AuthorsSchema.XML")
        dsXML.ReadXml("C:\Authors.XML")

        ' Looks for duplicated records
        FindDuplicate(ds, dsXML)

        ' If found errors, print out them
        ' Otherwise merge the dataset
        If (dsXML.HasErrors = False) Then
            ds.Merge(dsXML)
            Console.WriteLine("Merge done!")
        Else
            PrintErrors(dsXML)
        End If
    End Sub

End Module
