using System;
using System.Xml;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace Example1
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		private static SqlConnection dbConn;

		private static void PrintErrors(DataTable t)
		{
			DataRow[] r = t.GetErrors();

			for(int i=0;i<r.Length;i++)
			{
				Console.WriteLine("AuthorID: " + r[i]["AuthorID"] + " - " + r[i].RowError);
			}
		}

		private static bool FindErrorsInTable(SqlConnection c, DataTable t)
		{
			SqlCommand sql = new SqlCommand();
			bool bError = false;

			if (c.State == ConnectionState.Closed)
				c.Open();

			for(int i=0;i<t.Rows.Count;i++)
			{
				string strSQL = "SELECT AuthorID FROM tabAuthors WHERE AuthorID=" + t.Rows[i]["AuthorID"].ToString();
				sql.CommandText = strSQL;
				sql.Connection = c;

				SqlDataReader reader = sql.ExecuteReader();
				if (reader.Read())
				{
					t.Rows[i].RowError = "This value already exists.";
					bError = true;
				}
				reader.Close();
			}

			if (c.State == ConnectionState.Open)
				c.Close();

			return bError;
		}

		public static void Main()
		{
			dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=WroxDB");
			
			try
			{
				// Retrieve the table schema from the Database
				SqlDataAdapter da = new SqlDataAdapter("SELECT AuthorID, Author_FirstName, Author_LastName FROM tabAuthors",dbConn);
				DataTable dt = new DataTable("WroxAuthors");
				da.FillSchema(dt,SchemaType.Source);

				// Fill a dataset with XML document records
				DataSet ds = new DataSet("NewAuthors");
				ds.ReadXml("C:\\Authors.xml");  // CHange this path with yours

				// Copying data from dataset to datatable
				dt = ds.Tables[0];

				// Create Insert command automatically
				SqlCommandBuilder builder = new SqlCommandBuilder(da);

				// Looks for errors				
				bool bErrors = FindErrorsInTable(dbConn, dt);

				// If no errors founded Update the table
				// otherwise print the errors
				if(!bErrors)
				{
					da.Update(dt);
					dt.AcceptChanges();
					Console.WriteLine("Records are stored successfully");
				}
				else
				{
					PrintErrors(dt);
					dt.RejectChanges();
				}
			}
			catch (Exception e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				if (dbConn.State == ConnectionState.Open)
					dbConn.Close();
			}
		}
	}
}
