using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DataViewDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.DataGrid dataGrid2;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private DataTable m_userTable;
	
		private DataViewManager m_dvm;
		private DataSet			m_ds;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			m_userTable = new DataTable ( "USERS" );

			BuildTable (); 

			// create the DataSet object 
			m_ds = new DataSet ();

			// create the DataViewManager with the DataSet 
			m_dvm = new DataViewManager ( m_ds );

			m_ds.Tables.Add ( m_userTable );

			CopyTable();

			CustomizeView (); 
		}

		private void CustomizeView ()
		{
	        m_dvm.DataViewSettings["USERS"].Sort = "USER_NAME";
    	}  

		private void CopyTable ()
		{
			// make a copy of the table 
			DataTable copiedTable = m_userTable.Copy ();

			// rename the table 
			copiedTable.TableName = "USERS_2";

			// now modify some of its' data 
			copiedTable.Rows[0]["USER_NAME"] = "ADAMSF"; 
			copiedTable.Rows[0]["FULL_NAME"] = "FRANK ADAMS";
			copiedTable.Rows[0]["USER_TYPE"] = "Administrator";
			copiedTable.Rows[0]["PASSWORD"] = "Administrator";

			// add the table to the dataset
			m_ds.Tables.Add ( copiedTable ); 	  
		}  

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.dataGrid2 = new System.Windows.Forms.DataGrid();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(336, 288);
			this.button1.Name = "button1";
			this.button1.TabIndex = 2;
			this.button1.Text = "Fill";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// dataGrid2
			// 
			this.dataGrid2.DataMember = "";
			this.dataGrid2.Location = new System.Drawing.Point(8, 160);
			this.dataGrid2.Name = "dataGrid2";
			this.dataGrid2.Size = new System.Drawing.Size(408, 120);
			this.dataGrid2.TabIndex = 1;
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.Location = new System.Drawing.Point(8, 8);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(408, 144);
			this.dataGrid1.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 317);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button1,
																		  this.dataGrid2,
																		  this.dataGrid1});
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dataGrid2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			dataGrid1.SetDataBinding ( m_dvm, "USERS" ); 
			dataGrid2.SetDataBinding ( m_dvm, "USERS_2" );

			//dataGrid1.SetDataBinding ( m_userView, "" ); 
			//dataGrid2.SetDataBinding ( m_deletedUsersView, "" );
		}

		private void BuildTable ()
		{
			// create the columns for the table
			DataColumn userIDCol = new DataColumn ("USER_ID", typeof (long));
			DataColumn userNameCol = new DataColumn ("USER_NAME", typeof(string));
			DataColumn fullNameCol = new DataColumn ("FULL_NAME", typeof(string));
			DataColumn userTypeCol = new DataColumn ("USER_TYPE", typeof(string)); 
			DataColumn passWordCol = new DataColumn ("PASSWORD", typeof(string));

			// add the columns to the tables' columns collection
			m_userTable.Columns.Add ( userIDCol );
			m_userTable.Columns.Add ( userNameCol );
			m_userTable.Columns.Add ( fullNameCol );
			m_userTable.Columns.Add ( userTypeCol ); 
			m_userTable.Columns.Add ( passWordCol );

			// now create some new rows to store the user info
			DataRow row1 = m_userTable.NewRow ();
			DataRow row2 = m_userTable.NewRow ();
			DataRow row3 = m_userTable.NewRow ();
			DataRow row4 = m_userTable.NewRow ();
			DataRow row5 = m_userTable.NewRow ();
			DataRow row6 = m_userTable.NewRow ();
			DataRow row7 = m_userTable.NewRow ();
			DataRow row8 = m_userTable.NewRow ();

			// set the information for each user 
			row1[ "USER_ID" ] = 1;
			row1[ "USER_NAME" ] = "DICKINSONP";
			row1[ "FULL_NAME" ] = "Paul Dickinson";
			row1[ "USER_TYPE" ] = "Administrator"; 
			row1[ "PASSWORD" ] = "Sausages";

			row2[ "USER_ID" ] = 2;
			row2[ "USER_NAME" ] = "SMITHL";
			row2[ "FULL_NAME" ] = "Larry Smith";
			row2[ "USER_TYPE" ] = "User"; 
			row2[ "PASSWORD" ] = "SMITHL";

			row3[ "USER_ID" ] = 3;
			row3[ "USER_NAME" ] = "ODELLS";
			row3[ "FULL_NAME" ] = "Sue O'Dell";
			row3[ "USER_TYPE" ] = "Manager"; 
			row3[ "PASSWORD" ] = "Index Finger";

			row4[ "USER_ID" ] = 4;
			row4[ "USER_NAME" ] = "HARRISC";
			row4[ "FULL_NAME" ] = "Claire Harris";
			row4[ "USER_TYPE" ] = "User"; 
			row4[ "PASSWORD" ] = "Parsnip";
 
			row5[ "USER_ID" ] = 5;
			row5[ "USER_NAME" ] = "BRIGGSK";
			row5[ "FULL_NAME" ] = "Keith Briggs";
			row5[ "USER_TYPE" ] = "User"; 
			row5[ "PASSWORD" ] = "Fred";

			row6[ "USER_ID" ] = 6;
			row6[ "USER_NAME" ] = "LITTLEN";
			row6[ "FULL_NAME" ] = "Ned Little";
			row6[ "USER_TYPE" ] = "Manager"; 
			row6[ "PASSWORD" ] = "BingoHall";

			row7[ "USER_ID" ] = 7;
			row7[ "USER_NAME" ] = "CULLENT";
			row7[ "FULL_NAME" ] = "Tim Cullen";
			row7[ "USER_TYPE" ] = "User"; 
			row7[ "PASSWORD" ] = "Tights";

			row8[ "USER_ID" ] = 8;
			row8[ "USER_NAME" ] = "WARRINGTONJ";
			row8[ "FULL_NAME" ] = "Jan Warrington";
			row8[ "USER_TYPE" ] = "User"; 
			row8[ "PASSWORD" ] = "Pesky Kids";

			// add the rows to table
			m_userTable.Rows.Add ( row1 );
			m_userTable.Rows.Add ( row2 );
			m_userTable.Rows.Add ( row3 );
			m_userTable.Rows.Add ( row4 );
			m_userTable.Rows.Add ( row5 );
			m_userTable.Rows.Add ( row6 );
			m_userTable.Rows.Add ( row7 );
			m_userTable.Rows.Add ( row8 );

			// confirm the changes we've made to the table 
			m_userTable.AcceptChanges ();
		}
	}
}
