Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Drawing
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Configuration

Namespace DayOfDotNet

	Public Class CustomerOrderDataGrid
		Inherits System.Web.UI.Page
		
		Protected CustomerDataGrid As DataGrid
		Private ds As DataSet = New DataSet()

		Private Sub Page_Load(sender As object, e As System.EventArgs)
			Dim sqlStmt As String = "SELECT * FROM Customers; SELECT * FROM Orders"
			Dim conString As String = ConfigurationSettings.AppSettings("NWDConString")
			
			Dim sda As SqlDataAdapter = New SqlDataAdapter(sqlStmt, conString)

			sda.Fill(ds)
			ds.Tables(0).TableName = "Customers"
			ds.Tables(1).TableName = "Orders"
			
			CustomerDataGrid.DataSource = ds.Tables("Customers")
			CustomerDataGrid.DataBind()
		End Sub

		'Use the OnItemCreated event handler to dynamically add an embedded DataGrid
		Protected Sub CustomerDataGrid_OnItemDataBound(sender As object, e As DataGridItemEventArgs)
			'When each row is created in the DataGrid, eval the ItemType
			If e.Item.ItemType = ListItemType.Item XOr e.Item.ItemType = ListItemType.AlternatingItem Then
				'If the ItemType is Item or AlternatingItem, 
				'Create a New DataGrid object named OrdersDataGrid
				Dim OrdersDataGrid As DataGrid = New DataGrid()
				
				'Format the DataGrid to look cool.
				OrdersDataGrid.BorderWidth = Unit.Pixel(1)
				OrdersDataGrid.CellPadding = 4
				OrdersDataGrid.CellSpacing = 0
				OrdersDataGrid.GridLines = GridLines.Horizontal
				OrdersDataGrid.BorderColor = Color.FromName("Black")
				
				OrdersDataGrid.ItemStyle.Font.Name = "Verdana"
				OrdersDataGrid.ItemStyle.Font.Size = FontUnit.XSmall
				
				OrdersDataGrid.AlternatingItemStyle.BackColor = Color.FromName("LightGray")
				
				OrdersDataGrid.ShowHeader = True
				OrdersDataGrid.HeaderStyle.BackColor = Color.FromName("Black")
				OrdersDataGrid.HeaderStyle.ForeColor = Color.FromName("White")
				OrdersDataGrid.HeaderStyle.Font.Bold = True
				OrdersDataGrid.HeaderStyle.Font.Size = FontUnit.XSmall

				
				'Do not autogenerate columns.
				OrdersDataGrid.AutoGenerateColumns = False
				
				'****Add a series of BoundColumns****'
				'***Order ID***?
				Dim bc As BoundColumn = New BoundColumn()
				'Set the BoundColumn Values
				bc.HeaderText = "Order ID"
				bc.DataField = "OrderID"
				bc.ItemStyle.Wrap = False
				'Add the BoundColumn to the OrdersDataGrid.
				OrdersDataGrid.Columns.Add(bc)

				'***Order Date***?
				bc = New BoundColumn()
				bc.HeaderText = "Order Date"
				bc.DataField = "OrderDate"
				bc.DataFormatString="{0:d}"
				bc.ItemStyle.Wrap = False
				OrdersDataGrid.Columns.Add(bc)

				'***Required Date***?
				bc = New BoundColumn()
				bc.HeaderText = "Required Date"
				bc.DataField = "RequiredDate"
				bc.DataFormatString="{0:d}"
				bc.ItemStyle.Wrap = False
				OrdersDataGrid.Columns.Add(bc)

				'***Shipped Date***/
				bc = New BoundColumn()
				bc.HeaderText = "Shipped Date"
				bc.DataField = "ShippedDate"
				bc.DataFormatString="{0:d}"
				bc.ItemStyle.Wrap = False
				OrdersDataGrid.Columns.Add(bc)
				
				'****End BoundColumns****'
				
				
				'Get the Authors DataView and filter it for the current ISBN
				Dim _orders As DataView = ds.Tables("Orders").DefaultView
				_orders.RowFilter = "CustomerID='" & e.Item.Cells(0).Text & "'"
				
				'Bind the DataGrid.
				OrdersDataGrid.DataSource = _orders
				OrdersDataGrid.DataBind()
				
				'Add the OrdersDataGrid to the BooksDataGrid.
				e.Item.Cells(3).Controls.Add(OrdersDataGrid)
			End If
		End Sub
	End Class
End Namespace