namespace PowerOfDotNet.Clubs.Board
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using MyWebLibs.Utilities;

	/// <summary>
	///		ClubEdit   Դϴ.
	/// </summary>
	public abstract class ClubEdit : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox txtSubject;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnFormat;
		protected System.Web.UI.WebControls.TextBox txtContent;
		protected System.Web.UI.HtmlControls.HtmlInputFile File1;
		protected System.Web.UI.HtmlControls.HtmlInputFile File2;
		protected System.Web.UI.HtmlControls.HtmlInputFile File3;
		protected System.Web.UI.HtmlControls.HtmlInputFile File4;
		protected System.Web.UI.HtmlControls.HtmlInputFile File5;
		protected System.Web.UI.HtmlControls.HtmlInputFile File6;
		protected System.Web.UI.HtmlControls.HtmlInputFile File7;
		protected System.Web.UI.HtmlControls.HtmlInputFile File8;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteAndList;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteAndBefore;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.CheckBox chkBox;
		protected System.Web.UI.WebControls.Panel pnlHeader;
		protected System.Web.UI.WebControls.CheckBox chkboxUseAvatar;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstAvatarExp;

		private PowerOfDotNet.Components.BoardClubInfo _blInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			//  ´.
			int boardId = CommonMethods.RequestInt(Request.Params["TableId"], -1);
			int clubId = CommonMethods.RequestInt(Request.Params["clubId"], -1);

			//߱Ⱓ  ̷ Ѵ.
			this.RemoveObjectCache("BoardClubTableInfo" + boardId);
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardClubInfo)this.GetObjectFromCache("BoardClubTableInfo" + boardId);
			if (_blInfo == null)
			{
				PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardClubTableInfo" + boardId, _blInfo, 30);
			}

			pnlHeader.Style["text-align"] = "center";
			//ŸƲ 
			switch (_blInfo.BBSDisplayType)
			{
				case 0 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSSubject));
					pnlHeader.Style["font-size"] = "16px";
					pnlHeader.Style["font-weight"] = "bold";
					break;
				case 1 :
					pnlHeader.Controls.Add(new LiteralControl("<img src='" + _blInfo.BBSImage + "' />"));
					break;
				case 2 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSHtml));
					break;
			}

			if (!IsPostBack)
			{
				Components.ClubInfo clubInfo = Clubs.ClubsUtil.GetClubInfo(this, clubId);
				bool gongJiAuthority = Clubs.ClubsUtil.CheckUserAuthorityForGongJi(Page.User.Identity.Name, clubInfo, _blInfo);
				if (!gongJiAuthority) MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Ŭ ڸ   ֽϴ.");

				PowerOfDotNet.Components.AvatarDB dbAvatar = new PowerOfDotNet.Components.AvatarDB();
				SqlDataReader drAvatarExp = dbAvatar.GetAvatarExpression();
				rdobtnlstAvatarExp.DataSource = drAvatarExp;
				rdobtnlstAvatarExp.DataTextField = "Description";
				rdobtnlstAvatarExp.DataValueField = "ID";
				rdobtnlstAvatarExp.DataBind();

				ViewState["before"] = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["before"], "").Replace("^","=").Replace("$","&");
				ViewState["genParam"] = "page=" + MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["page"],"") +
					"&TableId=" + boardId + "&clubId=" + clubId;

				int pid = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["pid"], 0);
				ViewState["pid"] = pid;
				PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
				SqlDataReader dr = db.GetContent(_blInfo.BBSTable, pid);
				dr.Read();
				txtContent.Text = dr.GetString(3);
				txtSubject.Text = dr.GetString(1);
				rdobtnFormat.SelectedIndex = dr.GetByte(6);
				chkboxUseAvatar.Checked = dr.GetBoolean(10);
				rdobtnlstAvatarExp.SelectedIndex = (int)dr.GetByte(11);

				this.Form.Enctype = "multipart/form-data";
			}
			MyWebLibs.Utilities.CommonMethods.SetFocus(txtContent);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnWriteAndList.ServerClick += new System.EventHandler(this.btnWriteAndList_ServerClick);
			this.btnWriteAndBefore.ServerClick += new System.EventHandler(this.btnWriteAndBefore_ServerClick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnWriteAndList_ServerClick(object sender, System.EventArgs e)
		{
			if (Page.IsValid)
			{
				PowerOfDotNet.Components.BoardClubData oData = MakeDbData();
				bool bPreserve = chkBox.Checked;
				PowerOfDotNet.Components.BoardClubDB oDb = new PowerOfDotNet.Components.BoardClubDB();
				oDb.Modify(_blInfo.BBSTable, oData, Request.Files, bPreserve);
				Response.Redirect(GetLink(_blInfo.BBSPageNameList) + "&" + (string)ViewState["genParam"]);
			}
		}

		private void btnWriteAndBefore_ServerClick(object sender, System.EventArgs e)
		{
			if (Page.IsValid)
			{
				PowerOfDotNet.Components.BoardClubData oData = MakeDbData();
				bool bPreserve = chkBox.Checked;
				PowerOfDotNet.Components.BoardClubDB oDb = new PowerOfDotNet.Components.BoardClubDB();
				oDb.Modify(_blInfo.BBSTable, oData, Request.Files, bPreserve);
				Response.Redirect((string)ViewState["before"]);
			}
		}

		private PowerOfDotNet.Components.BoardClubData MakeDbData()
		{
			PowerOfDotNet.Components.BoardClubData oData = new PowerOfDotNet.Components.BoardClubData();

			oData.PID = Convert.ToInt32(ViewState["pid"]);
			oData.Subject = txtSubject.Text;
			oData.Format = Convert.ToByte(rdobtnFormat.SelectedItem.Value);
			oData.Content = txtContent.Text;
			oData.UserIP = Request.ServerVariables["REMOTE_ADDR"];
			oData.UseAvatar = chkboxUseAvatar.Checked;
			oData.AvatarExpression = Convert.ToByte(rdobtnlstAvatarExp.SelectedItem.Value);

			return oData;
		}

	}
}
