using System;
using System.Web;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;

namespace PowerOfDotNet.Components
{
	public class BoardClubData
	{
		public int PID;
		public int MID;
		public string Subject;
		public string Writer;
		public string Email;
		public string Content;
		public string Password;
		public string UserIP;
		public string UserID;
		public byte Format;
		public byte FileCount;
		public bool UseAvatar;
		public byte AvatarExpression;
	}

	public class BoardClubInfo
	{
		public int BBSID;
		public string BBSSubject;
		public string BBSTable;
		public string BBSHtml;
		public string BBSImage;
		public byte BBSDisplayType;
		//public string BBSRoles;
		public string BBSImageHeadName;
		public string BBSCssClassHead;
		public byte BBSType; //0-Ϲ, 1-
		public string BBSPageNameList;
		public string BBSPageNameWrite;
		public string BBSPageNameEdit;
		public string BBSPageNameReply;
		public string BBSPageNameContent;
	}

	/// <summary>
	/// BoardClubDB   Դϴ.
	/// </summary>
	public class BoardClubDB
	{
		public BoardClubDB()
		{
		}

		public int GetBoardIdBySubject(string bbsSubject)
		{
			string sql = "select BBSID from ClubsBoardInfo where BBSSubject='" + bbsSubject + "'";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			int ret = -1;
			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader();
			if (dr.Read())
				ret = dr.GetInt32(0);

			dr.Close();
			myConnection.Close();

			return ret;
		}

		public BoardClubInfo GetBoardInfo(int boardId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand getTablenameCmd = new SqlCommand("SP_Club_GET_BOARD_INFO", myConnection);

			getTablenameCmd.CommandType = CommandType.StoredProcedure;

			SqlParameter parameterBoardID = new SqlParameter("@BoardID", SqlDbType.Int);
			parameterBoardID.Value = boardId;
			getTablenameCmd.Parameters.Add(parameterBoardID);

			myConnection.Open();
			SqlDataReader dr = getTablenameCmd.ExecuteReader();
			dr.Read();
			BoardClubInfo blinfo= new BoardClubInfo();
			blinfo.BBSID = (int)dr["ID"];
			blinfo.BBSSubject = (string)dr["Subject"];
			blinfo.BBSTable = (string)dr["TableName"];
			blinfo.BBSHtml = (string)dr["Html"];
			blinfo.BBSDisplayType = (byte)dr["DisplayType"];
			blinfo.BBSImage = (string)dr["Image"];
			//blinfo.BBSRoles = (string)dr["Roles"];
			blinfo.BBSImageHeadName = (string)dr["ImageHeadName"];
			blinfo.BBSCssClassHead = (string)dr["CssClassHead"];
			blinfo.BBSType = (byte)dr["Type"];
			blinfo.BBSPageNameContent = (string)dr["PageNameContent"];
			blinfo.BBSPageNameEdit = (string)dr["PageNameEdit"];
			blinfo.BBSPageNameList = (string)dr["PageNameList"];
			blinfo.BBSPageNameReply = (string)dr["PageNameReply"];
			blinfo.BBSPageNameWrite = (string)dr["PageNameWrite"];

			dr.Close();
			myConnection.Close();

			return blinfo;

		}

		public int UpdateBBSInfo(BoardClubInfo blInfo)
		{

			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_CLUB_UpdateBoardInfo", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;

			myCommand.Parameters.Add(new SqlParameter("@BoardID", SqlDbType.Int, 4)).Value = blInfo.BBSID;
			myCommand.Parameters.Add(new SqlParameter("@BBSSubject", SqlDbType.NVarChar, 50)).Value = blInfo.BBSSubject;
			myCommand.Parameters.Add(new SqlParameter("@BBSTable", SqlDbType.NVarChar, 50)).Value = blInfo.BBSTable;
			myCommand.Parameters.Add(new SqlParameter("@BBSHtml", SqlDbType.NText)).Value = blInfo.BBSHtml;
			myCommand.Parameters.Add(new SqlParameter("@BBSDisplayType", SqlDbType.TinyInt)).Value = blInfo.BBSDisplayType;
			myCommand.Parameters.Add(new SqlParameter("@BBSImage", SqlDbType.VarChar, 80)).Value = blInfo.BBSImage;
			//myCommand.Parameters.Add(new SqlParameter("@BBSRoles", SqlDbType.NVarChar, 50)).Value = blInfo.BBSRoles;
			myCommand.Parameters.Add(new SqlParameter("@BBSImageHeadName", SqlDbType.VarChar, 40)).Value = blInfo.BBSImageHeadName;
			myCommand.Parameters.Add(new SqlParameter("@BBSCssClassHead", SqlDbType.VarChar, 20)).Value = blInfo.BBSCssClassHead;
			myCommand.Parameters.Add(new SqlParameter("@BBSType", SqlDbType.TinyInt)).Value = blInfo.BBSType;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameContent", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameContent;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameEdit", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameEdit;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameList", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameList;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameReply", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameReply;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameWrite", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameWrite;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();

			return Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value);
		}


		public SqlDataReader GetSqlRecentSubject(string tableName, int topCount)
		{
			string sql = "select top " + topCount + " Subject, Writer, TreeID from " + tableName + " order by LinkID desc";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand getSubjectCmd = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = getSubjectCmd.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetList(string tableName, int intPage, int intRowCount, out int intRecCount, out int intPageCount)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			
			SqlCommand myCommand = new SqlCommand("SP_Club_BOARD_LIST_COUNT", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PAGE", SqlDbType.Int, 4)).Value = intPage;

			myCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.Parameters["@ROW_COUNT"].Direction = ParameterDirection.InputOutput;

			SqlParameter parameterAscCount = new SqlParameter("@ASC_Count", SqlDbType.Int);
			parameterAscCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterAscCount);

			SqlParameter parameterRecCount = new SqlParameter("@RecCount", SqlDbType.Int);
			parameterRecCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterRecCount);

			SqlParameter parameterPageCount = new SqlParameter("@PageCount", SqlDbType.Int);
			parameterPageCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterPageCount);

			SqlParameter parameterTableName2 = new SqlParameter("@TableName", SqlDbType.NVarChar);
			parameterTableName2.Value = tableName;
			myCommand.Parameters.Add(parameterTableName2);

			myConnection.Open();
			myCommand.ExecuteNonQuery();

			intRowCount = (int)myCommand.Parameters["@ROW_COUNT"].Value;
			int ascCount = (int)parameterAscCount.Value;
			intRecCount = (int)parameterRecCount.Value;
			intPageCount = (int)parameterPageCount.Value;
			
			myCommand = new SqlCommand("SP_Club_BOARD_LIST", myConnection);
			myCommand.CommandType = CommandType.StoredProcedure;
			myCommand.Parameters.Add(new SqlParameter("@ASC_COUNT", SqlDbType.Int, 4)).Value = ascCount;
			myCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			//dr.Close();

			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetListWithWhere(string tableName, int intPage, int intRowCount, string where, out int intRecCount, out int intPageCount)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);

			SqlCommand myCommand = new SqlCommand("SP_Club_BOARD_LIST_WITH_WHERE_COUNT", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PAGE", SqlDbType.Int, 4)).Value = intPage;

			myCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.Parameters["@ROW_COUNT"].Direction = ParameterDirection.InputOutput;

			SqlParameter parameterAscCount = new SqlParameter("@ASC_Count", SqlDbType.Int);
			parameterAscCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterAscCount);

			SqlParameter parameterRecCount = new SqlParameter("@RecCount", SqlDbType.Int);
			parameterRecCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterRecCount);

			SqlParameter parameterPageCount = new SqlParameter("@PageCount", SqlDbType.Int);
			parameterPageCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterPageCount);

			SqlParameter parameterPageCountWhere = new SqlParameter("@Where", SqlDbType.NVarChar, 200);
			parameterPageCountWhere.Value = where;
			myCommand.Parameters.Add(parameterPageCountWhere);

			SqlParameter parameterTableName2 = new SqlParameter("@TableName", SqlDbType.NVarChar);
			parameterTableName2.Value = tableName;
			myCommand.Parameters.Add(parameterTableName2);

			myConnection.Open();
			myCommand.ExecuteNonQuery();

			intRowCount = (int)myCommand.Parameters["@ROW_COUNT"].Value;
			int ascCount = (int)parameterAscCount.Value;
			intRecCount = (int)parameterRecCount.Value;
			intPageCount = (int)parameterPageCount.Value;
			
			myCommand = new SqlCommand("SP_Club_BOARD_LIST_WITH_WHERE", myConnection);
			myCommand.CommandType = CommandType.StoredProcedure;
			myCommand.Parameters.Add(new SqlParameter("@ASC_COUNT", SqlDbType.Int, 4)).Value = ascCount;
			myCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.Parameters.Add(new SqlParameter("@WHERE_CLAUSE", SqlDbType.NVarChar, 200)).Value = where;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			//dr.Close();

			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}


		public SqlDataReader GetListByMid(string tableName, int mid)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_Club_BOARD_LIST_BY_MID", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@MID", SqlDbType.Int, 4)).Value = mid;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetContent(string tableName, int intPID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_Club_GET_CONTENT", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = intPID;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetFileInfo(string tableName, int intPID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_Club_GET_FILEINFO", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = intPID;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public void AddNew(string tableName, BoardClubData oData, HttpFileCollection UploadFiles)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand bbsCommand = new SqlCommand("SP_Club_ADD_ROW", myConnection);

			bbsCommand.CommandType = CommandType.StoredProcedure;
			bbsCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			bbsCommand.Parameters.Add(new SqlParameter("@SUBJECT", SqlDbType.VarChar, 100)).Value = oData.Subject;
			bbsCommand.Parameters.Add(new SqlParameter("@WRITER", SqlDbType.NVarChar, 20)).Value = oData.Writer;
			bbsCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.NVarChar, 12)).Value = oData.UserID;
			bbsCommand.Parameters.Add(new SqlParameter("@EMAIL", SqlDbType.VarChar, 40)).Value = oData.Email;
			bbsCommand.Parameters.Add(new SqlParameter("@CONTENT", SqlDbType.Text)).Value = oData.Content;
			bbsCommand.Parameters.Add(new SqlParameter("@PASSWORD", SqlDbType.VarChar, 12)).Value = oData.Password;
			bbsCommand.Parameters.Add(new SqlParameter("@USERIP", SqlDbType.VarChar, 20)).Value = oData.UserIP;
			bbsCommand.Parameters.Add(new SqlParameter("@FORMAT", SqlDbType.TinyInt, 1)).Value = oData.Format;
			bbsCommand.Parameters.Add(new SqlParameter("@UseAvatar", SqlDbType.Bit)).Value = oData.UseAvatar;
			bbsCommand.Parameters.Add(new SqlParameter("@AvatarExpression", SqlDbType.TinyInt, 1)).Value = oData.AvatarExpression;

			bbsCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			int fileCount = 0;
			//   ϱ ̴.
			for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
			{
				HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
				String strFileName = Path.GetFileName(_postedFile.FileName);
				if (strFileName != "") fileCount++;
			}
			bbsCommand.Parameters.Add(new SqlParameter("@FILECOUNT", SqlDbType.TinyInt, 1)).Value = fileCount;

			myConnection.Open();

			string sqlInsertFile = "insert into " + tableName + "Files (blfPID,blfFileName,blfSize,blfContent) ";
			sqlInsertFile += "VALUES (@PID, @FileName, @Size, @Content)";

			SqlCommand bbsFileCommand = new SqlCommand(sqlInsertFile, myConnection);

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			bbsCommand.Transaction = stTrans;
			bbsFileCommand.Transaction = stTrans;

			try
			{
				bbsCommand.ExecuteNonQuery();

				for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
				{
					HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
					String strFileName = Path.GetFileName(_postedFile.FileName);

					if (strFileName == "") continue;

					int intSize = _postedFile.ContentLength;
					System.Byte[] FileByteArray = new System.Byte[intSize];
					Stream StreamObj = _postedFile.InputStream;
					StreamObj.Read(FileByteArray,0,intSize);

					bbsFileCommand.Parameters.Clear();
					bbsFileCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = Convert.ToInt64(bbsCommand.Parameters["RETURN_VALUE"].Value);
					bbsFileCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.BigInt)).Value = intSize;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Content", SqlDbType.Image)).Value = FileByteArray;

					bbsFileCommand.ExecuteNonQuery();
				}

				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}
		}

		public void Modify(string tableName, BoardClubData oData, HttpFileCollection UploadFiles, bool bPreserve)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand bbsCommand = new SqlCommand("SP_Club_MODIFY_ROW", myConnection);

			bbsCommand.CommandType = CommandType.StoredProcedure;
			bbsCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = oData.PID;
			bbsCommand.Parameters.Add(new SqlParameter("@SUBJECT", SqlDbType.VarChar, 100)).Value = oData.Subject;
			//bbsCommand.Parameters.Add(new SqlParameter("@WRITER", SqlDbType.VarChar, 20)).Value = oData.Writer;
			//bbsCommand.Parameters.Add(new SqlParameter("@EMAIL", SqlDbType.VarChar, 40)).Value = oData.Email;
			bbsCommand.Parameters.Add(new SqlParameter("@CONTENT", SqlDbType.Text)).Value = oData.Content;
			//bbsCommand.Parameters.Add(new SqlParameter("@PASSWORD", SqlDbType.VarChar, 12)).Value = oData.Password;
			bbsCommand.Parameters.Add(new SqlParameter("@USERIP", SqlDbType.VarChar, 20)).Value = oData.UserIP;
			bbsCommand.Parameters.Add(new SqlParameter("@FORMAT", SqlDbType.TinyInt, 1)).Value = oData.Format;
			bbsCommand.Parameters.Add(new SqlParameter("@UseAvatar", SqlDbType.Bit)).Value = oData.UseAvatar;
			bbsCommand.Parameters.Add(new SqlParameter("@AvatarExpression", SqlDbType.TinyInt, 1)).Value = oData.AvatarExpression;

			bbsCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			int fileCount = 0;
			//   ϱ ̴.
			for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
			{
				HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
				String strFileName = Path.GetFileName(_postedFile.FileName);
				if (strFileName != "") fileCount++;
			}
			
			string sqlFileCount = "select count(*) from " + tableName + "Files where blfPID=" + oData.PID.ToString();
			SqlCommand bbsFileCountCommand = new SqlCommand(sqlFileCount, myConnection);

			myConnection.Open();
			SqlDataReader bfDr = bbsFileCountCommand.ExecuteReader();
			bfDr.Read();
			fileCount += bfDr.GetInt32(0);
			bfDr.Close();
			bbsCommand.Parameters.Add(new SqlParameter("@FILECOUNT", SqlDbType.TinyInt, 1)).Value = fileCount;

			string sqlDeleteFile = "delete from " + tableName + "Files where blfPID=@PID";
			string sqlInsertFile = "insert into " + tableName + "Files (blfPID,blfFileName,blfSize,blfContent) ";
			sqlInsertFile += "VALUES (@PID, @FileName, @Size, @Content)";
			
			SqlCommand bbsFileDeleteCommand = new SqlCommand(sqlDeleteFile, myConnection);
			SqlCommand bbsFileInsertCommand = new SqlCommand(sqlInsertFile, myConnection);

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			bbsCommand.Transaction = stTrans;
			bbsFileInsertCommand.Transaction = stTrans;
			bbsFileDeleteCommand.Transaction = stTrans;

			try
			{
				bbsCommand.ExecuteNonQuery();
				if (!bPreserve)
				{// ϵ .
					bbsFileDeleteCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = oData.PID;
					bbsFileDeleteCommand.ExecuteNonQuery();
				}

				for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ )
				{
					HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
					String strFileName = Path.GetFileName(_postedFile.FileName);

					if (strFileName == "") continue;

					int intSize = _postedFile.ContentLength;
					System.Byte[] FileByteArray = new System.Byte[intSize];
					Stream StreamObj = _postedFile.InputStream;
					StreamObj.Read(FileByteArray,0,intSize);

					bbsFileInsertCommand.Parameters.Clear();
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = oData.PID;
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.BigInt)).Value = intSize;
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@Content", SqlDbType.Image)).Value = FileByteArray;

					bbsFileInsertCommand.ExecuteNonQuery();
				}
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}
		}

		public int InsertReply(string tableName, BoardClubData oData, HttpFileCollection UploadFiles)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand bbsCommand = new SqlCommand("SP_Club_INSERT_REPLY_ROW", myConnection);

			bbsCommand.CommandType = CommandType.StoredProcedure;
			bbsCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			bbsCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = oData.PID;
			//bbsCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;
			bbsCommand.Parameters.Add(new SqlParameter("@SUBJECT", SqlDbType.VarChar, 100)).Value = oData.Subject;
			bbsCommand.Parameters.Add(new SqlParameter("@WRITER", SqlDbType.VarChar, 20)).Value = oData.Writer;
			bbsCommand.Parameters.Add(new SqlParameter("@EMAIL", SqlDbType.VarChar, 40)).Value = oData.Email;
			bbsCommand.Parameters.Add(new SqlParameter("@CONTENT", SqlDbType.Text)).Value = oData.Content;
			bbsCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 20)).Value = oData.UserID;
			bbsCommand.Parameters.Add(new SqlParameter("@USERIP", SqlDbType.VarChar, 20)).Value = oData.UserIP;
			bbsCommand.Parameters.Add(new SqlParameter("@FORMAT", SqlDbType.TinyInt, 1)).Value = oData.Format;
			bbsCommand.Parameters.Add(new SqlParameter("@UseAvatar", SqlDbType.Bit)).Value = oData.UseAvatar;
			bbsCommand.Parameters.Add(new SqlParameter("@AvatarExpression", SqlDbType.TinyInt, 1)).Value = oData.AvatarExpression;

			bbsCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			int fileCount = 0;
			//   ϱ ̴.
			for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
			{
				HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
				String strFileName = Path.GetFileName(_postedFile.FileName);
				if (strFileName != "") fileCount++;
			}
			bbsCommand.Parameters.Add(new SqlParameter("@FILECOUNT", SqlDbType.TinyInt, 1)).Value = fileCount;

			myConnection.Open();

			string sqlInsertFile = "insert into " + tableName + "Files (blfPID,blfFileName,blfSize,blfContent) ";
			sqlInsertFile += "VALUES (@PID, @FileName, @Size, @Content)";

			SqlCommand bbsFileCommand = new SqlCommand(sqlInsertFile, myConnection);

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			bbsCommand.Transaction = stTrans;
			bbsFileCommand.Transaction = stTrans;

			try
			{
				bbsCommand.ExecuteNonQuery();

				for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
				{
					HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
					String strFileName = Path.GetFileName(_postedFile.FileName);

					if (strFileName == "") continue;

					int intSize = _postedFile.ContentLength;
					System.Byte[] FileByteArray = new System.Byte[intSize];
					Stream StreamObj = _postedFile.InputStream;
					StreamObj.Read(FileByteArray,0,intSize);

					bbsFileCommand.Parameters.Clear();
					bbsFileCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = Convert.ToInt32(bbsCommand.Parameters["RETURN_VALUE"].Value);
					bbsFileCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.BigInt)).Value = intSize;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Content", SqlDbType.Image)).Value = FileByteArray;

					bbsFileCommand.ExecuteNonQuery();
				}
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}
			return Convert.ToInt32(bbsCommand.Parameters["RETURN_VALUE"].Value);
		}

		public int DeleteOne(string tableName, int intPID, int intMID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_Club_BOARD_DELETE_ONE", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			myCommand.Parameters.Add(new SqlParameter("@FeedPID", SqlDbType.Int, 4)).Value = intPID;
			myCommand.Parameters.Add(new SqlParameter("@FeedMID", SqlDbType.Int, 4)).Value = intMID;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			string sqlDeleteFile = "delete from " + tableName + "Files where blfPID=@PID";

			SqlCommand bbsFileDeleteCommand = new SqlCommand(sqlDeleteFile, myConnection);

			bbsFileDeleteCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = intPID;
			
			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			myCommand.Transaction = stTrans;
			bbsFileDeleteCommand.Transaction = stTrans;

			int ret = -1;
			try
			{
				myCommand.ExecuteNonQuery();
				ret = Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value);
				if (ret == -1)
				{
					myConnection.Close();
					return -1; //  ڵ尡 ִ.
				}

				// ϵ .
				bbsFileDeleteCommand.ExecuteNonQuery();
				
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
				ret = -2; //db 
			}
			finally
			{
				myConnection.Close();
			}

			return ret;
		}

		public void IncVisted(string tableName, int intPID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_Club_INCREASE_VISTED", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.BigInt)).Value = intPID;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}

	}
}
