using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;

namespace PowerOfDotNet.Components
{
	/// <summary>
	/// JoiningDB   Դϴ.
	/// </summary>
	public class JoiningDB
	{
		public bool CheckUserIDDup(String userID) 
		{
			// Create Instance of Connection and Command Object
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("CheckUserIDDup", myConnection);

			// Mark the Command as a SPROC
			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			SqlParameter parameterUserId = new SqlParameter("@UserID", SqlDbType.VarChar, 12);
			myCommand.Parameters.Add(parameterUserId);
			parameterUserId.Value = userID;

			// Open the connection and execute the Command
			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();

			return Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value) == 1;
		}

		public SqlDataReader GetZipAddress(string s3)
		{

			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("GetZipAddrs", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@S3", SqlDbType.NVarChar, 20)).Value = s3;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public int AddUser(string userID, String Name, String email, String password, string Joomin, 
					DateTime birthday, string zip, string phone, string address1, string address2, 
					string userDir, string userRootDir) 
		{
			// Create Instance of Connection and Command Object
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("AddJoiningUser", myConnection);

			// Mark the Command as a SPROC
			myCommand.CommandType = CommandType.StoredProcedure;

			// Add Parameters to SPROC
			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;

			SqlParameter parameterName = new SqlParameter("@Name", SqlDbType.NVarChar, 20);
			parameterName.Value = Name;
			myCommand.Parameters.Add(parameterName);

			SqlParameter parameterEmail = new SqlParameter("@Email", SqlDbType.NVarChar, 100);
			parameterEmail.Value = email;
			myCommand.Parameters.Add(parameterEmail);

			SqlParameter parameterPassword = new SqlParameter("@Password", SqlDbType.VarChar, 12);
			parameterPassword.Value = password;
			myCommand.Parameters.Add(parameterPassword);

			SqlParameter parameterUserId = new SqlParameter("@UserID", SqlDbType.NVarChar, 12);
			parameterUserId.Value = userID;
			myCommand.Parameters.Add(parameterUserId);

			SqlParameter parameterJoomin = new SqlParameter("@Joomin", SqlDbType.VarChar, 14);
			parameterJoomin.Value = Joomin;
			myCommand.Parameters.Add(parameterJoomin);

			SqlParameter parameterBirthday = new SqlParameter("@Birthday", SqlDbType.DateTime);
			parameterBirthday.Value = birthday;
			myCommand.Parameters.Add(parameterBirthday);

			SqlParameter parameterZip = new SqlParameter("@ZipNumber", SqlDbType.VarChar, 9);
			parameterZip.Value = zip;
			myCommand.Parameters.Add(parameterZip);

			SqlParameter parameterPhone = new SqlParameter("@Phone", SqlDbType.VarChar, 20);
			parameterPhone.Value = phone;
			myCommand.Parameters.Add(parameterPhone);

			SqlParameter parameterAddress1 = new SqlParameter("@Address1", SqlDbType.NVarChar, 100);
			parameterAddress1.Value = address1;
			myCommand.Parameters.Add(parameterAddress1);

			SqlParameter parameterAddress2 = new SqlParameter("@Address2", SqlDbType.NVarChar, 100);
			parameterAddress2.Value = address2;
			myCommand.Parameters.Add(parameterAddress2);

			SqlParameter parameterUserDir = new SqlParameter("@UserDirectory", SqlDbType.VarChar, 20);
			parameterUserDir.Value = userDir;
			myCommand.Parameters.Add(parameterUserDir);

			myConnection.Open();
			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			myCommand.Transaction = stTrans;
			
			try {
				myCommand.ExecuteNonQuery();
				Directory.CreateDirectory(userRootDir + "\\" + userDir + "\\" + userID);

				stTrans.Commit();

				return Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value);
			}
			catch (Exception e) {
				string err = e.Message;
				stTrans.Rollback();

				return -3;
			}
			finally {
				if (myConnection.State == ConnectionState.Open)
					myConnection.Close();
			}
		}

		public int ModifyUserInfo(string userID, String Name, String email, String password, string Joomin, 
			DateTime birthday, string zip, string phone, string address1, string address2, bool joominChanged) 
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("ModifyUserInfo", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;

			SqlParameter parameterUserId = new SqlParameter("@UserID", SqlDbType.NVarChar, 12);
			parameterUserId.Value = userID;
			myCommand.Parameters.Add(parameterUserId);

			SqlParameter parameterName = new SqlParameter("@Name", SqlDbType.NVarChar, 20);
			parameterName.Value = Name;
			myCommand.Parameters.Add(parameterName);

			SqlParameter parameterEmail = new SqlParameter("@Email", SqlDbType.NVarChar, 100);
			parameterEmail.Value = email;
			myCommand.Parameters.Add(parameterEmail);

			SqlParameter parameterPassword = new SqlParameter("@Password", SqlDbType.VarChar, 12);
			parameterPassword.Value = password;
			myCommand.Parameters.Add(parameterPassword);

			SqlParameter parameterJoomin = new SqlParameter("@Joomin", SqlDbType.VarChar, 14);
			parameterJoomin.Value = Joomin;
			myCommand.Parameters.Add(parameterJoomin);

			SqlParameter parameterBirthday = new SqlParameter("@Birthday", SqlDbType.DateTime);
			parameterBirthday.Value = birthday;
			myCommand.Parameters.Add(parameterBirthday);

			SqlParameter parameterZip = new SqlParameter("@ZipNumber", SqlDbType.VarChar, 9);
			parameterZip.Value = zip;
			myCommand.Parameters.Add(parameterZip);

			SqlParameter parameterPhone = new SqlParameter("@Phone", SqlDbType.VarChar, 20);
			parameterPhone.Value = phone;
			myCommand.Parameters.Add(parameterPhone);

			SqlParameter parameterAddress1 = new SqlParameter("@Address1", SqlDbType.NVarChar, 100);
			parameterAddress1.Value = address1;
			myCommand.Parameters.Add(parameterAddress1);

			SqlParameter parameterAddress2 = new SqlParameter("@Address2", SqlDbType.NVarChar, 100);
			parameterAddress2.Value = address2;
			myCommand.Parameters.Add(parameterAddress2);

			SqlParameter parameterJoominChanged = new SqlParameter("@JoominChanged", SqlDbType.Bit);
			parameterJoominChanged.Value = joominChanged;
			myCommand.Parameters.Add(parameterJoominChanged);

			

			myConnection.Open();
			
			try {
				myCommand.ExecuteNonQuery();

				return Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value);
			}
			catch (Exception e) {
				string err = e.Message;

				return -3;
			}
			finally {
				if (myConnection.State == ConnectionState.Open)
					myConnection.Close();
			}
		}
	}
}
