using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using System.Collections;

namespace Chapter19.Ex03
{
	public class Chap19_Ex03 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList DropDownList1;
		protected System.Web.UI.WebControls.DropDownList DropDownList2;
		protected System.Web.UI.WebControls.DropDownList DropDownList3;
		protected System.Web.UI.WebControls.DropDownList DropDownList4;
		protected System.Web.UI.WebControls.DropDownList DropDownList5;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				ListItem item;

				//DataSource DataReader ü 
				DropDownList1.DataSource = GetDataReader();
				DropDownList1.DataTextField = "item";
				DropDownList1.DataValueField = "id";
				DropDownList1.DataBind();
				item = new ListItem("*****  ó  *****", "0");
				DropDownList1.Items.Insert(0, item);

				//DataSource ArrayList ü 
				//ArrayList ü ϶ 
				//DataTextField DataValueField  ʴ´.
				DropDownList2.DataSource = GetArrayList();
				DropDownList2.DataBind();
				item = new ListItem("*****   ߰ *****", "100");
				DropDownList2.Items.Add(item);

				//DataSource DataView ü 
				DropDownList3.DataSource = GetDataView();
				DropDownList3.DataTextField = "ItemField";
				DropDownList3.DataValueField = "IdField";
				DropDownList3.DataBind();
				item = new ListItem("*****  °  *****", "30");
				DropDownList3.Items.Insert(2, item);

				DataSet ds = GetDataSet();
				//DataSource DataSet ü 
				DropDownList4.DataSource = ds;
				DropDownList4.DataTextField = "item";
				DropDownList4.DataValueField = "id";
				DropDownList4.DataMember = "DataPresentation1";
				DropDownList4.DataBind();

				//DataSource DataSet ü ̺ 
				DropDownList5.DataSource = 
					ds.Tables["DataPresentation1"];
				DropDownList5.DataTextField = "item";
				DropDownList5.DataValueField = "id";
				DropDownList5.DataBind();
			}
		}

		private SqlDataReader GetDataReader()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select id, item from tbDataPresentation1";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;

			dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		private ICollection GetArrayList()
		{
			ArrayList arrayList = new ArrayList();
			SqlDataReader dr = GetDataReader();

			while (dr.Read())
			{
				arrayList.Add(dr["item"]);
			}

			return arrayList;
		}

		ICollection GetDataView() 
		{
			DataTable dt = new DataTable();
			DataRow dataRow;
			SqlDataReader dr = GetDataReader();

			dt.Columns.Add(new DataColumn("IdField", typeof(Int32)));
			dt.Columns.Add(new DataColumn("ItemField", typeof(string)));

			while (dr.Read())
			{
				dataRow = dt.NewRow();

				dataRow[0] = dr["id"];
				dataRow[1] = dr["item"];

				dt.Rows.Add(dataRow);
			}

			return dt.DefaultView;
		}

		public DataSet GetDataSet()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			SqlConnection conn = new SqlConnection(strSqlConn);
			SqlDataAdapter da = new SqlDataAdapter("select id, item from tbDataPresentation1", conn);

			DataSet ds = new DataSet();
			da.Fill(ds, "DataPresentation1");

			return ds;
		}
 
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DropDownList1.SelectedIndexChanged += new System.EventHandler(this.DropDownList1_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void DropDownList1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//"[SELECTED] " ڿ ִ  ã 
			//"[SELECTED] " ڿ 
			string selSymbol = "[SELECTED] ";
			foreach (ListItem item in DropDownList1.Items)
			{
				if (item.Text.StartsWith(selSymbol))
					item.Text = item.Text.Substring(selSymbol.Length);
			}

			int selectedIndex = DropDownList1.SelectedIndex;
			DropDownList1.SelectedIndex = selectedIndex;
			//õ  Ѵ.
			ListItem selItem = DropDownList1.Items[selectedIndex];
			//Ǵ
			//ListItem item = DropDownList1.SelectedItem;

			Response.Write("õ  : " + selItem.Text + "<br>");
			Response.Write("õ   : " + selItem.Value + "<br>");
			selItem.Text = "[SELECTED] " + selItem.Text;

			/*
			//εϸ SelectedIndex Ӽ 0 Ǳ  
			//̵  Ѵ.
			int selectedIndex = DropDownList1.SelectedIndex;

			//ó  Ӽ ViewState Ǳ  
			//⼭ DataTextField, DataValueField Ӽ 
			// ʿ䰡 .
			DropDownList1.DataSource = GetDataReader();
			DropDownList1.DataBind();
			ListItem item1 = new ListItem("*****  ó  *****", "0");
			ListItem item2 = new ListItem("*****   ߰ *****", "1000");
			DropDownList1.Items.Insert(0, item1);
			DropDownList1.Items.Add(item2);

			DropDownList1.SelectedIndex = selectedIndex;
			//õ  Ѵ.
			ListItem selItem = DropDownList1.Items[selectedIndex];

			Response.Write("õ  : " + selItem.Text + "<br>");
			Response.Write("õ   : " + selItem.Value + "<br>");
			selItem.Text = "[SELECTED] " + selItem.Text;
			*/
		}
	}
}

