using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter19.Ex04
{
	public class Chap19_Ex04 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.ListBox ListBox1;
		protected System.Web.UI.WebControls.CheckBoxList CheckBoxList1;
		protected System.Web.UI.WebControls.Button Button1;

		const string PARAM_LISTBOX = "ListBox";
		const string PARAM_CHECKBOXLIST = "CheckBoxList";
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				ListBox1.DataSource = GetData();
				ListBox1.DataTextField = "item";
				ListBox1.DataValueField = "id";
				ListBox1.DataBind();
				SqlDataReader drSelected = GetDataSelected(PARAM_LISTBOX);
				while (drSelected.Read())
				{
					ListItem item = 
						ListBox1.Items.FindByValue(drSelected["itemId"].ToString());
					if (item == null)
						throw new Exception("ͺ̽    ֽϴ.");
					item.Selected = true;
				}

				CheckBoxList1.DataSource = GetData();
				CheckBoxList1.DataTextField = "item";
				CheckBoxList1.DataValueField = "id";
				CheckBoxList1.DataBind();
				drSelected = GetDataSelected(PARAM_CHECKBOXLIST);
				while (drSelected.Read())
				{
					ListItem item = 
						CheckBoxList1.Items.FindByValue(drSelected["itemId"].ToString());
					if (item == null)
						throw new Exception("ͺ̽    ֽϴ.");
					item.Selected = true;
				}
			}
		}

		private SqlDataReader GetData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select id, item from tbDataPresentation1";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;

			dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		private SqlDataReader GetDataSelected(string param)
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select controlName, itemId " + 
						"from tbDataPresentation1_Selected " + 
						"where controlName='" + param + "'";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;

			dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		private void DeleteByControlName(string contralName)
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "delete from tbDataPresentation1_Selected " + 
				"where controlName='" + contralName + "'";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			cmdSql.ExecuteNonQuery();
			sqlConn.Close();
		}

		private void InsertSelectedItem(string controlName, string itemId)
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "insert into tbDataPresentation1_Selected " + 
				"(controlName, itemId) " + 
				"values ('" + controlName + "', " + itemId + ")";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			cmdSql.ExecuteNonQuery();
			sqlConn.Close();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void Button1_Click(object sender, System.EventArgs e)
		{
			Response.Write("ListBox1 õ  :<br>");
			DeleteByControlName(PARAM_LISTBOX);
			foreach(ListItem item in ListBox1.Items)
				if(item.Selected)
				{
					InsertSelectedItem(PARAM_LISTBOX, item.Value);
					Response.Write("Text=" + item.Text + ", Value=" + item.Value + "<br>");
				}

			Response.Write("<br>CheckBoxList1 õ  :<br>");
			DeleteByControlName(PARAM_CHECKBOXLIST);
			foreach(ListItem item in CheckBoxList1.Items)
				if(item.Selected)
				{
					InsertSelectedItem(PARAM_CHECKBOXLIST, item.Value);
					Response.Write("Text=" + item.Text + ", Value=" + item.Value + "<br>");
				}
		}
	}
}
