using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Web.UI.WebControls;
using System.Configuration;
using System.Drawing;

namespace Chapter20.Ex02
{
	public class Chap20_Ex02 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				BindData();
			}
		}

		private void BindData()
		{
			DataGrid1.DataSource = GetData();
			DataGrid1.DataBind();
		}

		//  ͺ̽ ´.
		private SqlDataReader GetData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;

			dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		// id ͸ ͺ̽ .
		private void DeleteData(string id)
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "delete from tbDataPresentation2 " +
				"where id=" + id;
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			cmdSql.ExecuteNonQuery();
			sqlConn.Close();
		}

		// id ͸ ͺ̽ Ѵ.
		private void UpdateData(string id, string title, 
			string author, string price, string page, 
			DateTime publishDate, string description)
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "update tbDataPresentation2 set " +
				"title=@title, author=@author, price=@price, " +
				"page=@page, publishDate=@publishDate, " + 
				"description=@description " +
				"where id=@id";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			cmdSql.Parameters.Add("@id", SqlDbType.Int).Value = id;
			cmdSql.Parameters.Add("@title", SqlDbType.VarChar, 50).Value = title;
			cmdSql.Parameters.Add("@author", SqlDbType.VarChar, 20).Value = author;
			cmdSql.Parameters.Add("@price", SqlDbType.Money).Value = price;
			cmdSql.Parameters.Add("@page", SqlDbType.Int).Value = page;
			cmdSql.Parameters.Add("@publishDate", SqlDbType.DateTime).Value = publishDate;
			cmdSql.Parameters.Add("@description", SqlDbType.Text).Value = description;

			sqlConn.Open();
			cmdSql.ExecuteNonQuery();
			sqlConn.Close();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_ItemCommand);
			this.DataGrid1.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_CancelCommand);
			this.DataGrid1.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_EditCommand);
			this.DataGrid1.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_UpdateCommand);
			this.DataGrid1.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_DeleteCommand);
			this.DataGrid1.SelectedIndexChanged += new System.EventHandler(this.DataGrid1_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		//CommandName 'Edit' ȣȴ.
		private void DataGrid1_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			DataGrid1.EditItemIndex = e.Item.ItemIndex;
			BindData();
		}

		//CommandName 'Delete' ȣȴ.
		private void DataGrid1_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			string id = DataGrid1.DataKeys[e.Item.ItemIndex].ToString();
			DeleteData(id);

			DataGrid1.EditItemIndex = -1;
			BindData();
		}

		//CommandName 'Update' ȣȴ.
		private void DataGrid1_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			string id = DataGrid1.DataKeys[e.Item.ItemIndex].ToString();

			TextBox txtTitle = (TextBox)e.Item.Cells[3].Controls[0];
			TextBox txtAuthor = (TextBox)e.Item.Cells[4].FindControl("txtAuthor");
			TextBox txtPrice = (TextBox)e.Item.Cells[4].FindControl("txtPrice");
			TextBox txtPage = (TextBox)e.Item.Cells[4].FindControl("txtPage");
			Calendar calPublishDate = (Calendar)e.Item.Cells[4].FindControl("calPublishDate");
			TextBox txtDescription = (TextBox)e.Item.Cells[4].FindControl("txtDescription");

			UpdateData(id, txtTitle.Text, txtAuthor.Text, 
				txtPrice.Text, txtPage.Text, 
				calPublishDate.SelectedDate, txtDescription.Text);

			DataGrid1.EditItemIndex = -1;
			BindData();
		}

		//CommandName 'Cancel'̸ ȣȴ.
		private void DataGrid1_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			DataGrid1.EditItemIndex = -1;
			BindData();
		}

		// ̺Ʈ ȣȴ.
		private void DataGrid1_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int index = e.Item.ItemIndex + 1;

			switch (e.CommandName)
			{
				case  "UserDefine" :
					Response.Write(index + "° ׸ 'Any' ư !<br>");
					break;
				case "Delete" :
					Response.Write(index + "° ׸ '' ư !<br>");
					break;
				case "Edit" :
					Response.Write(index + "° ׸ '' ư !<br>");
					break;
				case "Update" :
					Response.Write(index + "° ׸ '' ư !<br>");
					break;
				case "Cancel" :
					Response.Write(index + "° ׸ '' ư !<br>");
					break;
				case "Select" :
					Response.Write(index + "° ׸ '' ư !<br>");
					break;
			}
		}

		//CommandName 'Select' ȣȴ.
		private void DataGrid1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			BindData();
			DataGrid dg = (DataGrid)sender;
			dg.Items[dg.SelectedIndex].BackColor = Color.CadetBlue;
		}
	}
}
