using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Label
{
	[DefaultProperty("Text"),
	ParseChildren(false),
	ToolboxData("<{0}:SimpleLabel runat=server></{0}:SimpleLabel>")]
	public class SimpleLabel : WebControl
	{
		[Bindable(true), 
		Category("Appearance"), 
		DefaultValue("")] 
		public string Text {
			get	{
				object o = ViewState["text"];
				return((o == null) ? String.Empty : (string)o);
			}

			set	{ViewState["text"] = value;}
		}

		protected override void AddParsedSubObject(object obj)
		{
			if (obj is LiteralControl)
				Text = ((LiteralControl)obj).Text;
		}

		protected override void RenderContents(HtmlTextWriter writer)
		{
			writer.Write(Text);
			base.RenderContents(writer);
		}
	}
}
