using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CustomControls.TemplatedControls
{
	[ParseChildren(true)]
	public class TemplatedControl2 : Control, INamingContainer
	{
		private ITemplate itemTemplate = null;
		private ITemplate alternatingTemplate = null;
		private String message = null;
		private int itemCount = 0;

		public String Message {
			get {return message;}
			set {message = value;}
		}

		public int ItemCount {
			get {return itemCount;}
			set {itemCount = value;}
		}

		[PersistenceMode(PersistenceMode.InnerProperty),
		TemplateContainer(typeof(TemplateItem))]
		public ITemplate ItemTemplate {
			get {return itemTemplate;}
			set {itemTemplate = value;}
		}

		[PersistenceMode(PersistenceMode.InnerProperty),
		TemplateContainer(typeof(TemplateItem))]
		public ITemplate AlternatingTemplate {
			get {return alternatingTemplate;}
			set {alternatingTemplate = value;}
		}

		protected override void CreateChildControls() 
		{
			Controls.Clear();

			for (int i=1;i<=itemCount;i++) {
				TemplateItem item = new TemplateItem(message, i);
				if (i % 2 == 1 || alternatingTemplate == null)
					itemTemplate.InstantiateIn(item);
				else
					alternatingTemplate.InstantiateIn(item);

				item.DataBind();
				Controls.Add(item);
			}
		}

		public class TemplateItem : Control, INamingContainer 
		{
			private String message = null;
			private int index;

			public TemplateItem(String msg, int idx) 
			{
				message = msg;
				index = idx;
			}

			public String Message {
				get {return message;}
				set {message = value;}
			}

			public int Index {
				get {return index;}
				set {index = value;}
			}
		}
	}
}
