using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Validators
{
	/// <summary>
	/// SimpleRequiredFieldValidator   Դϴ.
	/// </summary>
	[
	ToolboxData("<{0}:SimpleRequiredFieldValidator2 runat=server ErrorMessage=\"SimpleRequiredFieldValidator1\"></{0}:SimpleRequiredFieldValidator2>")
	]
	public class SimpleRequiredFieldValidator2 : SimpleBaseValidator2
	{
		[
		Category("Behavior"),
		DefaultValue("")
		]                                         
		public string InitialValue 
		{
			get 
			{ 
				object o = ViewState["InitialValue"];
				return((o == null) ? String.Empty : (string)o);
			}
			set {ViewState["InitialValue"] = value;}
		}

		protected override void AddAttributesToRender(HtmlTextWriter writer) 
		{
			base.AddAttributesToRender(writer);
			if (RenderUplevel) 
			{
				writer.AddAttribute("evaluationfunction", "RequiredFieldValidatorEvaluateIsValid");
				writer.AddAttribute("initialvalue", InitialValue);
			}
		} 

		protected override bool EvaluateIsValid() 
		{
			string controlValue = GetControlValidationValue(ControlToValidate);
			if (controlValue == null)
				throw new Exception("ControlToValidate  Ʈѿ ȿ ˻縦   ϴ.");

			return(!controlValue.Trim().Equals(InitialValue.Trim()));
		} 
	}
}
