using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data;
using System.Data.SqlClient;
using System.Data.OleDb;
using System.Configuration;

namespace MyDalApp
{
	public class MyWebForm : Page
	{
		protected DataGrid mySqlGrid;
		protected DataGrid myOleDbGrid;
		
		protected void Page_Load(object sender, EventArgs e)
		{
			//Create an instance of the DAL object
			UniversalDAL uDal = new UniversalDAL();

			//Create a SqlConnection
			SqlConnection sqlCon = new SqlConnection(ConfigurationSettings.AppSettings["NorthwindProdConString"]);
			//Call GetData() passing in a SqlConnection
			mySqlGrid.DataSource = uDal.GetData(sqlCon, "SELECT TOP 5 * FROM Customers");
			mySqlGrid.DataBind();
			sqlCon.Close();
			
			//Create an OleDbConnection
			OleDbConnection oledbCon = new OleDbConnection(ConfigurationSettings.AppSettings["NorthwindDevConString"]);
			//Call GetData() passing in an OleDbConnection
			myOleDbGrid.DataSource = uDal.GetData(oledbCon, "SELECT TOP 5 * FROM Products");
			myOleDbGrid.DataBind();
			oledbCon.Close();			
		}
	}
}