namespace PowerOfDotNet.NewStudy.DownloadBoard
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Data.SqlClient;
	using System.Collections;
	using PowerOfDotNet.TypedDataSet;

	/// <summary>
	///		List   Դϴ.
	/// </summary>
	public abstract class DownloadList : PowerOfDotNet.PortalModuleControlEx
	{
		//protected System.Web.UI.WebControls.DataGrid DownloadGrid;
		//protected PowerOfDotNet.Test.PagerSkinGrid DownloadGrid;
		protected MyWebLibs.ServerControls.PagerSkinGrid DownloadGrid;
		protected System.Web.UI.WebControls.Label lblSearchedCount;
		protected System.Web.UI.WebControls.DropDownList drpdnlstPagePerCount;
		protected System.Web.UI.WebControls.DropDownList drpdnlstPage;
		protected System.Web.UI.WebControls.PlaceHolder plhdlPager;
		protected System.Web.UI.WebControls.HyperLink hyplnkUpload;
		protected System.Web.UI.WebControls.DropDownList drpdnlstCategory;
		protected System.Web.UI.WebControls.DropDownList drpdnlstSort;
		protected System.Web.UI.WebControls.Button btnSearch;
		protected System.Web.UI.WebControls.TextBox txtSearchWord;

		protected System.Web.UI.WebControls.DataList DownloadContent;

		protected string _curentParams = "";

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				int page = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["page"], 0);
				int ppr = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["ppr"], 0);
				int category = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["ppr"], 0);
				int sort = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["sort"], 0);
				string searchWord = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["word"], "");

				DownloadGrid.CurrentPageIndex = page;
				drpdnlstPagePerCount.SelectedIndex = ppr;
				drpdnlstSort.SelectedIndex = sort;
				txtSearchWord.Text = searchWord;

				BindData();

				ArrayList ada = new ArrayList();
				for (int i=0; i<DownloadGrid.PageCount; i++)
				{
					ada.Add(i);
				}

				drpdnlstPage.DataSource = ada;
				drpdnlstPage.DataBind();

				//ī ε
				DataSet dsCategory = (DataSet)this.GetObjectFromCache("CategoryAspDotNetDS");
				if (dsCategory == null)
				{
					PowerOfDotNet.Components.DownloadDB db = new PowerOfDotNet.Components.DownloadDB();

					dsCategory = db.CategoryList();
					this.SetObjectToCache("CategoryAspDotNetDS", dsCategory, 30);
				}

				drpdnlstCategory.DataSource = dsCategory.Tables["CategoryAspDotNet"].DefaultView;
				drpdnlstCategory.DataTextField = "anCategory";
				drpdnlstCategory.DataValueField = "anID";
				drpdnlstCategory.DataBind();
				drpdnlstCategory.SelectedIndex = category;
			}
			else
			{
				HttpContext.Current.Items["DownloadList"] = this;
			}

			hyplnkUpload.NavigateUrl = GetLink("ڷǱ۾");
			
		}

		public void BindData() 
		{
			//DataTable dtDest = new DataTable();
			ArrayList aDest = new ArrayList();

			DownloadDS od = (DownloadDS)this.GetObjectFromCache("DownloadDS");
			if (od == null)
			{
				PowerOfDotNet.Components.DownloadDB db = new PowerOfDotNet.Components.DownloadDB();

				od = db.CreateDownloadDS();
				this.SetObjectToCache("DownloadDS", od, 30);
			}

			int intPageSize = DownloadGrid.PageSize;
			int intCurrentPage = DownloadGrid.CurrentPageIndex;
			int intTotalCount;

			bool useWordFilter = false;
			bool useCategoryFilter = false;
			bool useSort = false;
			if (ViewState["SearchWord"] != null)
				useWordFilter = true;
			if (ViewState["SelectedCategory"] != null)
				useCategoryFilter = true;
			if (ViewState["SelectedSort"] != null)
				useSort = true;

			if (!useWordFilter && !useCategoryFilter && !useSort)
			{
				intTotalCount = od.DownloadBoard.Rows.Count;
				DownloadGrid.VirtualItemCount = intTotalCount;
			
				int intStartRow = intCurrentPage * intPageSize;
				int intEndRow = (intStartRow+intPageSize <= intTotalCount) ? intStartRow+intPageSize : intTotalCount;

				//DownloadDS.DownloadBoardRow[] aRow = od.DownloadBoard.Select("", "dnID desc");
				for (int intIndex=intStartRow; intIndex < intEndRow; intIndex++)
				{
					PowerOfDotNet.NewStudy.DownloadBoard.ContentData ocd = new PowerOfDotNet.NewStudy.DownloadBoard.ContentData();

					ocd.ID = od.DownloadBoard[intIndex].dnID.ToString();
					ocd.WriterID = od.DownloadBoard[intIndex].dnWriterID;
					ocd.WriterName = od.DownloadBoard[intIndex].dnWriterName;
					ocd.Subject = od.DownloadBoard[intIndex].dnSubject;
					ocd.Description = od.DownloadBoard[intIndex].dnDescription;
					ocd.FilePath = od.DownloadBoard[intIndex].dnFileName;
					ocd.Rating = od.DownloadBoard[intIndex].dnRating.ToString();
					ocd.VoteCount = od.DownloadBoard[intIndex].dnVoteCount.ToString();
					ocd.CommentCount = od.DownloadBoard[intIndex].dnCommentCount.ToString();
					ocd.RegDate = od.DownloadBoard[intIndex].dnRegDate.ToString("yyyy MM dd");
					ocd.Catagory = od.DownloadBoard[intIndex].dnCategory.ToString();
					ocd.Language = Convert.ToInt32(od.DownloadBoard[intIndex].dnLanguage);
					ocd.Target = Convert.ToInt32(od.DownloadBoard[intIndex].dnTarget);
					ocd.DownloadCount = od.DownloadBoard[intIndex].dnDownloadCount.ToString();

					aDest.Add(ocd);
				}
			}
			else
			{
				string where = "";
				string orderBy = "";

				if (useWordFilter)
					where = "dnSubject like '%" + ViewState["SearchWord"].ToString() + "%'";
				if (useCategoryFilter)
				{
					if (where == "")
						where = "dnCategory=" + ViewState["SelectedCategory"].ToString();
					else
						where += " and dnCategory=" + ViewState["SelectedCategory"].ToString();
				}
				if (useSort)
					orderBy = ViewState["SelectedSort"].ToString();

				DataRow[] aRow = od.DownloadBoard.Select(where, orderBy);

				intTotalCount = aRow.Length;
				DownloadGrid.VirtualItemCount = intTotalCount;
			
				int intStartRow = intCurrentPage * intPageSize;
				int intEndRow = (intStartRow+intPageSize <= intTotalCount) ? intStartRow+intPageSize : intTotalCount;

				for (int intIndex=intStartRow; intIndex < intEndRow; intIndex++)
				{
					PowerOfDotNet.NewStudy.DownloadBoard.ContentData ocd = new PowerOfDotNet.NewStudy.DownloadBoard.ContentData();
				
					ocd.ID = aRow[intIndex]["dnID"].ToString();
					ocd.WriterID = aRow[intIndex]["dnWriterID"].ToString();
					ocd.Subject = aRow[intIndex]["dnSubject"].ToString();
					ocd.Description = aRow[intIndex]["dnDescription"].ToString();
					ocd.FilePath = aRow[intIndex]["dnFileName"].ToString();
					ocd.Rating = aRow[intIndex]["dnRating"].ToString();
					ocd.VoteCount = aRow[intIndex]["dnVoteCount"].ToString();
					ocd.CommentCount = aRow[intIndex]["dnCommentCount"].ToString();
					ocd.RegDate = Convert.ToDateTime(aRow[intIndex]["dnRegDate"]).ToString("yyyy MM dd");
					ocd.Catagory = aRow[intIndex]["dnCategory"].ToString();
					ocd.Language = Convert.ToInt32(aRow[intIndex]["dnLanguage"]);
					ocd.Target = Convert.ToInt32(aRow[intIndex]["dnTarget"]);
					ocd.DownloadCount = aRow[intIndex]["dnTarget"].ToString();

					aDest.Add(ocd);
				}
			}

			_curentParams = "page=" + DownloadGrid.CurrentPageIndex.ToString() + "&";
			_curentParams += "ppr=" + drpdnlstPagePerCount.SelectedIndex.ToString() + "&";
			_curentParams += "category=" + drpdnlstCategory.SelectedIndex.ToString() + "&";
			_curentParams += "sort=" + drpdnlstSort.SelectedIndex.ToString() + "&";
			_curentParams += "word=" + txtSearchWord.Text;

			DownloadGrid.DataSource = aDest;
			DownloadGrid.DataBind();
			lblSearchedCount.Text = DownloadGrid.VirtualItemCount.ToString();
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			this.PreRender += new System.EventHandler(Page_PreRender);
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			this.drpdnlstPagePerCount.SelectedIndexChanged += new System.EventHandler(this.drpdnlstPagePerCount_SelectedIndexChanged);
			this.drpdnlstPage.SelectedIndexChanged += new System.EventHandler(this.drpdnlstPage_SelectedIndexChanged);
			this.DownloadGrid.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.DownloadGrid_PageIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DownloadGrid_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			DownloadGrid.CurrentPageIndex = e.NewPageIndex;
			drpdnlstPage.SelectedIndex = e.NewPageIndex;
     	}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			if (IsPostBack)
				BindData();
		}

		private void drpdnlstPage_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DownloadGrid.CurrentPageIndex = ((DropDownList)sender).SelectedIndex;
		}

		private void drpdnlstPagePerCount_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DownloadGrid.PageSize = Convert.ToInt32(((DropDownList)sender).SelectedItem.Value);
			DownloadGrid.CurrentPageIndex = 0;

			//DownloadGrid.PageCount   Ⱦұ⶧
			int pageCount = (DownloadGrid.VirtualItemCount / DownloadGrid.PageSize) + 
						((DownloadGrid.VirtualItemCount % DownloadGrid.PageSize) == 0 ? 0 : 1);
			ArrayList ada = new ArrayList();
			for (int i=0; i<pageCount; i++)
			{
				ada.Add(i);
			}

			drpdnlstPage.DataSource = ada;
			drpdnlstPage.DataBind();
		}

		private void btnSearch_Click(object sender, System.EventArgs e)
		{
			if (txtSearchWord.Text.Trim() != "")
				ViewState["SearchWord"] = txtSearchWord.Text.Trim();
			else
				ViewState.Remove("SearchWord");

			// ʵȰ ALL õ 
			//Ͱ ʿ.
			if (drpdnlstCategory.SelectedIndex > 0) 
				ViewState["SelectedCategory"] = drpdnlstCategory.SelectedItem.Value;
			else
				ViewState.Remove("SelectedCategory");

			// ʵȰ  ʿ.
			if (drpdnlstSort.SelectedIndex > -1)
				ViewState["SelectedSort"] = drpdnlstSort.SelectedItem.Value;
			else
				ViewState.Remove("SelectedSort");
		}
	}
}
