namespace PowerOfDotNet.NewStudy.Lacture
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		LactureContent   Դϴ.
	/// </summary>
	public abstract class LactureContent : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.Button btnEdit;
		protected System.Web.UI.WebControls.Button btnReply;

		protected int _groupId;
		protected System.Web.UI.WebControls.Label lblContent;
		protected System.Web.UI.WebControls.Label lblViewed;
		protected System.Web.UI.WebControls.Label lblRegDate;
		protected System.Web.UI.WebControls.Label lblWriter;
		protected System.Web.UI.WebControls.Label lblSubject;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnToList;
		protected System.Web.UI.WebControls.PlaceHolder plachdrFiles;
		protected System.Web.UI.WebControls.LinkButton lnkbtnDelete;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnImitationDelete;
		protected PowerOfDotNet.Avatar.AvatarPlugIn Avatarplugin1;
		protected int _id;

		private string LactureDeleteConfirmScript = @"
<SCRIPT LANGUAGE=""JavaScript"">
<!--
function _PowerOf_LactureDeleteConfirm(id)
{{
		if (window.confirm(""Խù  Ͻðڽϱ?""))
			__doPostBack(id,'');
}}
//-->
</SCRIPT>
		";

		public int PID	{
			get	{return _id;}
			set	{_id = value;}
		}

		private PowerOfDotNet.Components.BoardLactureInfo _blInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();

			int boardId = Convert.ToInt32(Request.Params["TableId"]);
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardLactureInfo)this.GetObjectFromCache("BoardLactureTableInfo" + boardId);
			if (_blInfo == null) {
				_blInfo = db.GetBoardInfo(boardId);
				this.SetObjectToCache("BoardLactureTableInfo" + boardId, _blInfo, 30);
			}

			SqlDataReader dr = db.GetContent(_blInfo.BBSTable, _id);
			dr.Read();
			//Text 
			if (dr.GetByte(6) == 0)	{
				lblContent.Text = Server.HtmlEncode(dr.GetString(3)).Replace("\n","<br>");
			}
			else { // HTML 
				string strContentUri = "/NewStudy/Lacture/GetLactureHTMLContent.aspx?ID=" + _id.ToString() + "&Table=" + _blInfo.BBSTable + "&bypass=true";
				// iframe ̿ 
				LiteralControl oIFrame = new LiteralControl("<iframe src=\""+ strContentUri + "\" frameborder=0 scrolling=outo width=100% height=500 topmargin=0 leftmargin=10 marginheight=0 marginwidth=0 name=\"Content\" allowtransparency=\"true\"></iframe>");
				lblContent.Controls.Clear();
				lblContent.Controls.Add(oIFrame);
			}
			lblWriter.Text = dr.GetString(0);
			lblSubject.Text = dr.GetString(1);
			lblRegDate.Text = dr.GetDateTime(2).ToString();
			lblViewed.Text = dr.GetInt32(4).ToString();

			//ƹŸ ϸ
			if (dr.GetBoolean(10)) {
				//ƹŸ 
				//UserID Ӽ Ǿ ƹŸ Ѵ.
				Avatarplugin1.UserID = dr.GetString(9);
				Avatarplugin1.Expression = dr.GetByte(11).ToString();
			}
			else
				Avatarplugin1.Visible = false;

			//ȸ 
			object increaseCheck = this.Session["LactureForVistedIncrease"];
			if (increaseCheck == null) increaseCheck = (object)String.Empty;
			if ((string)increaseCheck != Request.RawUrl) {
				db.IncVisted(_blInfo.BBSTable, _id);
			}

			bool authority;
			
			if (PortalSecurity.IsInRoles(_blInfo.BBSRoles))	authority = true;
			else if (_blInfo.BBSType == 0 && dr["UserID"].ToString().Trim() == Page.User.Identity.Name)	authority = true;
			else	authority = false;

			//'' '' ư ڿ 
			// Ѵ.
			if (authority) {
				//LactureContentGroup GroupID 
				_groupId = ((LactureContentGroup)this.Parent.Parent.Parent).GroupInfo.GroupID;

				lnkbtnDelete.CommandArgument = _groupId.ToString() + ":" + _id.ToString() + ":" + _blInfo.BBSTable;
				//lnkbtnDelete.UniqueID ڷ Ѱش
				btnImitationDelete.Attributes["onclick"] = "_PowerOf_LactureDeleteConfirm('" + lnkbtnDelete.UniqueID + "')";
				btnEdit.CommandArgument = _id.ToString() + ":" + _blInfo.BBSID;
			}
			else {
				btnImitationDelete.Disabled = true;
				btnEdit.Enabled = false;
			}

			if (_blInfo.BBSType == 0)	authority = true;

			if (authority)
				btnReply.CommandArgument = _id.ToString() + ":" + _blInfo.BBSID;
			else
				btnReply.Visible = false;
		

			//÷ ũ 
			SqlDataReader drf = db.GetFileInfo(_blInfo.BBSTable, _id);
			while (drf.Read()) {
				HyperLink hl = new HyperLink();
				//mode=download  
				hl.NavigateUrl = "GetLactureImage.ashx?mode=download&ID=" + 
					_id.ToString() + "&Table=" + _blInfo.BBSTable + 
					"&FileName=" + drf.GetString(0);
				hl.Text = drf.GetString(0) + "(" + drf.GetInt32(1) + ")";
				plachdrFiles.Controls.Add(hl);
				plachdrFiles.Controls.Add(new LiteralControl("&nbsp;&nbsp;"));
			}

			string param = LactureUtil.GetGenParam();
			btnToList.Attributes["onclick"] = "window.location.href='" + GetLink(_blInfo.BBSPageNameList) + "&" + param + "'";

			//ũƮ  lnkbtnDelete ̺Ʈ ȣϴ Լ 
			Page.RegisterClientScriptBlock("LactureDeleteConfirmScript", LactureDeleteConfirmScript);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}

		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
