using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.Caching;

namespace MyWebLibs.Utilities
{
	public class CommonMethods
	{
		public CommonMethods()
		{
		}

		private static string strValid(string str, string strDefault)
		{
			string tmp="";
			try
			{
				tmp = str;
				tmp = tmp.Replace("'", "''");
			} 
			catch 
			{
				tmp = strDefault;
			}

			return tmp;
		}

		private static int intValid(string str, int intDefault)
		{
			int tmp=0;
			try
			{
				tmp = int.Parse(str);;
			} 
			catch 
			{
				tmp = intDefault;
			}

			return tmp;
		}

		/// <summary>
		///  Ķ 
		/// </summary>
		public static string RequestStr(string str1, string str2, string strDefault) 
		{
			string tmp;
			
			tmp=strValid(str1, strDefault);
			if (tmp != strDefault) return tmp;
			tmp=strValid(str2, strDefault);

			return tmp;
		}

		public static string RequestStr(string str1, string strDefault) 
		{
			string tmp;
			
			tmp=strValid(str1, strDefault);

			return tmp;
		}

		/// <summary>
		///  Ķ 
		/// </summary>
		public static int RequestInt(string str1, string str2, int intDefault) 
		{
			int tmp;

			tmp=intValid(str1, intDefault);
			if (tmp != intDefault) return tmp;
			tmp=intValid(str2, intDefault);

			return tmp;
		}

		public static int RequestInt(string str1, int intDefault) 
		{
			int tmp;

			tmp=intValid(str1, intDefault);

			return tmp;
		}

		/// <summary>
		/// MsgBox 
		/// </summary>
		/// <param name="strMessage">޼ ڽ  ڿ</param>
		public static void PrintMsg(string strMessage) 
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n	<!--\n" + 
			"		alert('" + strMessage + "');\n//-->\n	</script>\n";

			HttpContext.Current.Response.Write(strHTML);
		}
	
		/// <summary>
		/// MsgBox    â ݴ´.
		/// </summary>
		/// <param name="strMessage">޼ ڽ  ڿ</param>
		public static void PrintMsgAndClose(string strMessage) 
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n	<!--\n		alert('" + strMessage + "');\n" +
				"	self.close();\n" +
				"//-->\n	</script>\n";

			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		/// MsgBox    â ݴ´. ׸ Opener εѴ.
		/// </summary>
		/// <param name="strMessage">޼ ڽ  ڿ</param>
		public static void PrintMsgAndCloseAndOpenerReload(string strMessage) 
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n" + 
				"<!--\n		alert('" + strMessage + "');\n" +
				"	self.close();\n" +
				"	opener.document.location.reload();\n" +
				"//-->\n	</script>\n";

			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		/// MsgBox    𷺼
		/// </summary>
		/// <param name="strMessage">޼ ڽ  ڿ</param>
		/// <param name="redirUri">𷺼 ּ</param>
		public static void PrintMsgAndRedir(string strMessage, string redirUri) 
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n	<!--\n		alert('" + strMessage + "');\n" +
				"	window.document.location.href='" + redirUri + "';\n" +
				"//-->\n	</script>\n";

			//strHTML = "<script language=\"vbscript\">\n <!--\n		msgbox \"" + strMessage + "\"\n" +
			//	"	window.document.location.href=\"" + redirUri + "\"\n" +
			//	 "</script>\n";

			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}


		/// <summary>
		/// MsgBox   opener  𷺼
		/// </summary>
		/// <param name="strMessage">Ŭ̾Ʈ µ ڿ</param>
		/// <param name="redirUri">θâ ּ</param>
		public static void PrintMsgAndCloseAndOpenerRedir(string strMessage, string redirUri) 
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n	<!--\n		alert('" + strMessage + "');\n" +
				"	opener.document.location.href='" + redirUri + "';\n" +
				"	self.close();\n" +
				"//-->\n	</script>\n";

			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		/// MsgBox  ȭ ̵
		/// </summary>
		/// <param name="strMessage">Ŭ̾Ʈ µ ڿ</param>
		public static void PrintMsgBack(string strMessage)
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n" +
				"<!--\n" +
				"alert('" + strMessage + "');\n" +
				"history.back();\n" +
				"//-->\n" +
				"</script>\n";

			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		/// ޼ڽ    Ÿٿ ش url  ̵
		/// </summary>
		/// <param name="message">  ڿ</param>
		/// <param name="url"> ̵ URI</param>
		/// <param name="target">    </param>
		public static void PrintMsgRedirectTarget(string message, string url, string target)
		{
			string strHTML;
			strHTML = "<html>\n" +
				"<body onLoad=\"alert('" + message + "');document.redir.submit();\">\n" +
				"<form action=\"" + url + "\" target=\""+target+"\" name=redir method=post>\n" +
				"<input type=hidden name=name value=''>\n" +
				"</form>\n" +
				"</body>\n" +
				"</html>\n";
			
			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		///  Ÿٿ ش url  ̵
		/// </summary>
		/// <param name="url"> ̵ URI</param>
		/// <param name="target">    </param>
		public static void RedirectTarget(string url, string target)
		{
			string strHTML;
			strHTML = "<html>\n" +
				"<body onLoad=\"document.redir.submit();\">\n" +
				"<form action=\"" + url + "\" target=\""+target+"\" name=redir method=post>\n" +
				"<input type=hidden name=name value=''>\n" +
				"</form>\n" +
				"</body>\n" +
				"</html>\n";
			
			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		/// ƮѾȿ   ڽƮ ˻Ѵ.
		///  FindControl޼ҵ ڽ ֽ̹ ȿ ˻Ѵ.
		/// </summary>
		/// <param name="o"></param>
		/// <param name="sName"></param>
		/// <returns></returns>
		public static Control FindControlAll(Control o, string sName)
		{
			foreach(Control oChild in o.Controls)
			{
				if (oChild.ID == sName)
					return oChild;
				if (oChild.HasControls())
				{
					Control oFind = FindControlAll(oChild, sName);
					if (oFind != null)
						return oFind;
				}
			}

			return null;
		}

		/// <summary>
		/// Page Ŭ ü νź ã 
		/// </summary>
		/// <param name="op">˻ Page Ŭ</param>
		/// <returns>˻ HomlForm ä νź</returns>
		public static HtmlForm GetForm(Page op)
		{
			foreach(Control oc in op.Controls)
			{
				if(oc is HtmlForm)
					return (HtmlForm)oc;
			}

			throw new Exception("̻ϴ  ̾??");
		}

		/// <summary>
		/// ڷ Ѿ Ʈ ʱ Ŀ  Ѵ.
		///  ٸ  Լ ȣǾٸ Ͽ Ѵ
		/// </summary>
		/// <param name="oc">Ŀ  Ʈ</param>
		/// <returns> Ŀ   : true,  ̹ Ŀ  Ʈ  : false</returns>
		public static bool SetFocus(Control oc)
		{
			if (oc.Page == null)
				throw new Exception("SetFocus ޼ҵ ڴ  ߰ ƮѸ Ͻ  ֽϴ.");

			string ClientFocusScript = @"
<script language=""javascript"">
<!--
function _StartupFocus()
{{
	document.{0}.{1}.focus();
}}

-->
</script>
			";

			if (!oc.Page.IsStartupScriptRegistered("_ClientFocusScript"))
			{
				ClientFocusScript = String.Format(ClientFocusScript, GetForm(oc.Page).ClientID, oc.ClientID);
				oc.Page.RegisterStartupScript("_ClientFocusScript", ClientFocusScript);
				RegisterOnloadFunction(oc.Page, "_StartupFocus()");
				return true;
			}
			else
				return false;
		}

		/// <summary>
		/// Ŭ̾Ʈ Onload̺Ʈ  Լ Ѵ.
		/// </summary>
		/// <param name="page">Page Ŭ</param>
		/// <param name="functionName"> Լ</param>
		public static void RegisterOnloadFunction(Page page, string functionName)
		{
			if (!page.IsClientScriptBlockRegistered("_ClientOnloadOnScript"))
			{
				string ClientOnloadOnScript = @"
<script language=""javascript"">
<!--
	function _OnloadExectionFunction()
	{
		for (var i=0; i<__onloadFunctionArray.length; i++)
		{
			eval(__onloadFunctionArray[i]);
		}
	}

	window.onload = _OnloadExectionFunction;
-->
</script>
			";

				page.RegisterClientScriptBlock("_ClientOnloadOnScript", ClientOnloadOnScript);
			}

			page.RegisterArrayDeclaration("__onloadFunctionArray", "'"+ functionName + "'");
		}

		//ٸ    Ű Ʈ Ѵ.
		public static void SetObjectToCache(string key, object toCache, int lifeMinute)
		{
			HttpContext.Current.Cache.Insert("__Obj"+key, toCache, null, DateTime.Now.AddMinutes(lifeMinute), TimeSpan.Zero, CacheItemPriority.High, null);
		}

		//ٸ    Ű Ʈ ´.
		public static object GetObjectFromCache(string key)
		{
			return HttpContext.Current.Cache["__Obj"+key];
		}

		//ٸ    Ű Ʈ ɽÿ Ѵ.
		public static void RemoveObjectCache(string key)
		{
			HttpContext.Current.Cache.Remove("__Obj"+key);
		}
	}
}
