using System;
using System.IO;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;

namespace PowerOfDotNet.Components
{
	/// <summary>
	/// WebmailDB   Դϴ.
	/// </summary>
	public class WebmailDB
	{
		public WebmailDB()
		{
		}

		public int AddReceptionCheck(string userId, string subject, string to)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand receptionCommand = new SqlCommand("WebmailAddReceptionCheck", myConnection);

			receptionCommand.CommandType = CommandType.StoredProcedure;

			receptionCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			receptionCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;
			receptionCommand.Parameters.Add(new SqlParameter("@Subject", SqlDbType.VarChar, 200)).Value = subject;
			receptionCommand.Parameters.Add(new SqlParameter("@To", SqlDbType.VarChar, 2000)).Value = to;

			myConnection.Open();

			int newId = -1;
			try 
			{
				receptionCommand.ExecuteNonQuery();
				newId = Convert.ToInt32(receptionCommand.Parameters["RETURN_VALUE"].Value);
			}
			catch (Exception err)
			{
				string s = err.Message;
			}
			finally
			{
				myConnection.Close();
			}

			return newId;
		}

		/*
		@UserID char(12),
		@Name nvarchar(20),
		@Email varchar(100),
		@FriendUserID char(12),
		@Phone varchar(20)
		*/
		public int AddAddressBook(string userId, string name, string email, string friendUserId, string phone)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand addressBookCommand = new SqlCommand("AddAddressBook", myConnection);

			addressBookCommand.CommandType = CommandType.StoredProcedure;

			addressBookCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			addressBookCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;
			addressBookCommand.Parameters.Add(new SqlParameter("@Name", SqlDbType.NVarChar, 20)).Value = name;
			addressBookCommand.Parameters.Add(new SqlParameter("@Email", SqlDbType.VarChar, 100)).Value = email;
			addressBookCommand.Parameters.Add(new SqlParameter("@FriendUserID", SqlDbType.Char, 12)).Value = friendUserId;
			addressBookCommand.Parameters.Add(new SqlParameter("@Phone", SqlDbType.VarChar, 20)).Value = phone;

			myConnection.Open();
			addressBookCommand.ExecuteNonQuery();
			int newId = Convert.ToInt32(addressBookCommand.Parameters["RETURN_VALUE"].Value);
			myConnection.Close();

			return newId;
		}

		public void DeleteAddressBook(int id)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand addressBookCommand = new SqlCommand("DeleteAddressBook", myConnection);

			addressBookCommand.CommandType = CommandType.StoredProcedure;

			addressBookCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;

			myConnection.Open();
			addressBookCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public DataSet GetUserAddressBook(string userId, string sortMethod)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);

			string sql = "select * from AddressBook where UserID=@UserID order by " + sortMethod;
			SqlDataAdapter da = new SqlDataAdapter(sql, myConnection);
			//SqlDataAdapter da = new SqlDataAdapter("GetAddressBookList", myConnection);
			//da.SelectCommand.CommandType = CommandType.StoredProcedure;

			da.SelectCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;

			DataSet ds = new DataSet();
			da.Fill(ds, "AddressBook");
			
			return ds;
		}

		public SqlDataReader GetOneAddressBook(int id)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand addressBookCommand = new SqlCommand("GetOneAddressBook", myConnection);

			addressBookCommand.CommandType = CommandType.StoredProcedure;

			addressBookCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;

			myConnection.Open();
			SqlDataReader dr = addressBookCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public void UpdateOneAddressBook(int id, string name, string email, 
										string phone, string friendUserId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand addressBookCommand = new SqlCommand("UpdateOneAddressBook", myConnection);

			addressBookCommand.CommandType = CommandType.StoredProcedure;
			addressBookCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;
			addressBookCommand.Parameters.Add(new SqlParameter("@Name", SqlDbType.NVarChar, 20)).Value = name;
			addressBookCommand.Parameters.Add(new SqlParameter("@Email", SqlDbType.VarChar, 100)).Value = email;
			addressBookCommand.Parameters.Add(new SqlParameter("@Phone", SqlDbType.VarChar, 20)).Value = phone;
			addressBookCommand.Parameters.Add(new SqlParameter("@FriendUserID", SqlDbType.VarChar, 12)).Value = friendUserId;

			myConnection.Open();
			addressBookCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public void SetReception(int id)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand receptionCommand = new SqlCommand("WebmailSetReception", myConnection);

			receptionCommand.CommandType = CommandType.StoredProcedure;
			receptionCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;

			myConnection.Open();
			receptionCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public DataSet GetReceptionCheckList(string userId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);

			SqlDataAdapter da = new SqlDataAdapter("WebmailGetReceptionCheckList", myConnection);

			da.SelectCommand.CommandType = CommandType.StoredProcedure;

			da.SelectCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;

			DataSet ds = new DataSet();
			da.Fill(ds, "ReceptionCheckList");
			
			return ds;
		}

		public void DeleteReception(int id)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand delMailCommand = new SqlCommand("WebmailDeleteReception", myConnection);

			delMailCommand.CommandType = CommandType.StoredProcedure;
			
			delMailCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;

			myConnection.Open();
			try 
			{
				delMailCommand.ExecuteNonQuery();
			}
			catch (Exception err)
			{
				string s = err.Message;
			}
			finally
			{
				myConnection.Close();
			}
		}

		public DataSet GetUserMailList(string userId, byte mailBoxType)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);

			SqlDataAdapter da = new SqlDataAdapter("WebmailGetUserMailList", myConnection);

			da.SelectCommand.CommandType = CommandType.StoredProcedure;

			da.SelectCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;
			da.SelectCommand.Parameters.Add(new SqlParameter("@MailBoxType", SqlDbType.TinyInt)).Value = mailBoxType;

			DataSet ds = new DataSet();
			da.Fill(ds, "AvatarItems");
			
			return ds;
		}

		public int GetUserNetYetReadMailCount(string userId, byte mailBoxType)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("WebmailGetUserNetYetReadMailCount", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;
			myCommand.Parameters.Add(new SqlParameter("@MailBoxType", SqlDbType.TinyInt)).Value = mailBoxType;

			myConnection.Open();
			int mailCount = (int)myCommand.ExecuteScalar();
			myConnection.Close();

			return mailCount;
		}

		public int GetUserMailCount(string userId, byte mailBoxType)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("WebmailGetUserMailCount", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;
			myCommand.Parameters.Add(new SqlParameter("@MailBoxType", SqlDbType.TinyInt)).Value = mailBoxType;

			myConnection.Open();
			int mailCount = (int)myCommand.ExecuteScalar();
			myConnection.Close();

			return mailCount;
		}

		public int GetUserMailTotalSize(string userId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("WebmailUserMailTotalSize", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;

			myConnection.Open();
			int mailTotalSize = (int)myCommand.ExecuteScalar();
			myConnection.Close();

			return mailTotalSize;
		}

		public SqlDataReader GetMailContent(int id)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("WebmailGetMailContent", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.VarChar, 12)).Value = id;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public void UserMailViewed(int id)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("WebmailUserMailViewed", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.VarChar, 12)).Value = id;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public int DeleteMail(int id, string dir)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand delMailCommand = new SqlCommand("WebmailDeleteMail", myConnection);
			SqlCommand getAttachedInfoCommand = new SqlCommand("WebmailGetMailAttachedInfo", myConnection);

			delMailCommand.CommandType = CommandType.StoredProcedure;
			
			delMailCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			delMailCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;

			getAttachedInfoCommand.CommandType = CommandType.StoredProcedure;
			getAttachedInfoCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;

			int success = 1;
			myConnection.Open();
			try 
			{
				delMailCommand.ExecuteNonQuery();
				SqlDataReader drAttInfo = getAttachedInfoCommand.ExecuteReader();
				while (drAttInfo.Read())
				{
					string filePath = dir + drAttInfo["SavedFileName"].ToString();
					if (File.Exists(filePath))
						File.Delete(filePath);
				}
				success = Convert.ToInt32(delMailCommand.Parameters["RETURN_VALUE"].Value);
			}
			catch (Exception err)
			{
				string s = err.Message;
				success = -1;
			}
			finally
			{
				myConnection.Close();
			}

			return success;
		}


		public int MoveMailBox(int id, byte mailBoxType)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("WebmailMailBoxMove", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;
			myCommand.Parameters.Add(new SqlParameter("@MailBoxType", SqlDbType.TinyInt)).Value = mailBoxType;

			int success = 1;
			myConnection.Open();
			try 
			{
				myCommand.ExecuteNonQuery();
			}
			catch (Exception err)
			{
				string s = err.Message;
				success = -1;
			}
			finally
			{
				myConnection.Close();
			}

			return success;
		}

		public int AddMail(string userId, string subject, string textBody, string htmlBody, 
			string to, string from, string cc, string bcc, int mailSize, string sentOn, 
			byte mailBoxType, string attachedFiles, string sourceDir, string destDir)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand mailCommand = new SqlCommand("WebmailInsertMessage", myConnection);
			SqlCommand attachCommand = new SqlCommand("WebmailAddAttachFile", myConnection);

			mailCommand.CommandType = CommandType.StoredProcedure;

			mailCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			mailCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;
			mailCommand.Parameters.Add(new SqlParameter("@Subject", SqlDbType.VarChar, 200)).Value = subject;
			mailCommand.Parameters.Add(new SqlParameter("@TextBody", SqlDbType.Text)).Value = textBody;
			mailCommand.Parameters.Add(new SqlParameter("@HtmlBody", SqlDbType.Text)).Value = htmlBody;
			mailCommand.Parameters.Add(new SqlParameter("@From", SqlDbType.VarChar, 100)).Value = from;
			mailCommand.Parameters.Add(new SqlParameter("@To", SqlDbType.VarChar, 2000)).Value = to;
			mailCommand.Parameters.Add(new SqlParameter("@Cc", SqlDbType.VarChar, 2000)).Value = cc;
			mailCommand.Parameters.Add(new SqlParameter("@Bcc", SqlDbType.VarChar, 2000)).Value = bcc;
			mailCommand.Parameters.Add(new SqlParameter("@FileAttach", SqlDbType.Bit)).Value = (attachedFiles != String.Empty);
			mailCommand.Parameters.Add(new SqlParameter("@MailSize", SqlDbType.Int)).Value = mailSize;
			mailCommand.Parameters.Add(new SqlParameter("@SentOn", SqlDbType.VarChar, 50)).Value = sentOn;
			mailCommand.Parameters.Add(new SqlParameter("@MailBoxType", SqlDbType.TinyInt)).Value = mailBoxType;

			int success = 1;
			myConnection.Open();

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			mailCommand.Transaction = stTrans;
			attachCommand.Transaction = stTrans;
			try 
			{
				mailCommand.ExecuteNonQuery();
				int newId = Convert.ToInt32(mailCommand.Parameters["RETURN_VALUE"].Value);
				string[] aFiles = attachedFiles.Split(new char[] {';'});
				foreach (string fi in aFiles)
				{
					string[] aFi = fi.Split(new char[] {','});
					//fi String.Empty 
					if (aFi.Length < 2)
						continue;

					string savedFileName = "mailAtt" + newId.ToString() + "_" + aFi[0].ToString();

					if (File.Exists(destDir + savedFileName))
					{
						int i = 0;
						while (File.Exists(destDir + savedFileName + i.ToString()))	i++;
						savedFileName = savedFileName + i.ToString();
					}

					attachCommand.Parameters.Clear();
					attachCommand.CommandType = CommandType.StoredProcedure;
					attachCommand.Parameters.Add(new SqlParameter("@MailID", SqlDbType.Int)).Value = newId;
					attachCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.VarChar)).Value = aFi[0];
					attachCommand.Parameters.Add(new SqlParameter("@SavedFileName", SqlDbType.VarChar)).Value = savedFileName;
					attachCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.Int)).Value = aFi[1];
					attachCommand.ExecuteNonQuery();

					File.Copy(sourceDir + aFi[0], destDir + savedFileName);
				}
				stTrans.Commit();
			}
			catch (Exception err)
			{
				string s = err.Message;
				success = -1;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}

			return success;
		}

	}
}
