using System;
using System.IO;
using System.Web;
using System.Web.Caching;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace PowerOfDotNet.NewStudy.Lacture
{
	public class GetLactureImage : IHttpHandler
	{
		public void ProcessRequest(HttpContext context)
		{
			int intID = Convert.ToInt32(context.Request.QueryString["ID"]);
			string tableName = context.Request.QueryString["Table"].ToString();
			string strFileName = context.Request.QueryString["FileName"].ToString();
			string strMode = MyWebLibs.Utilities.CommonMethods.RequestStr(context.Request.QueryString["mode"],"");

			SqlConnection Con = new SqlConnection(ConfigurationSettings.AppSettings["ConnectionString"]);

			try
			{
				Con.Open();

				string SqlCmd = "SELECT * FROM " + tableName + "Files WHERE blfPID = @ID and blfFileName = @FileName";
				SqlCommand sqlDbCmdObj = new SqlCommand(SqlCmd, Con);
				sqlDbCmdObj.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = intID;
				sqlDbCmdObj.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;

				SqlDataReader sqlReader = sqlDbCmdObj.ExecuteReader();

				sqlReader.Read();

				if (strMode == "download")
				{
					context.Response.AddHeader("Content-Disposition","attachment;filename="+ context.Server.UrlEncode(strFileName) );
					context.Response.ContentType = "application/unknown";
					context.Response.OutputStream.Write((byte[])sqlReader["blfContent"], 0, (int)sqlReader["blfSize"]);
				}
				else
				{
					context.Response.OutputStream.Write((byte[])sqlReader["blfContent"], 0, (int)sqlReader["blfSize"]);
				}
			}
			catch (Exception err) 
			{
				string s = err.Message;//
			}
			finally
			{
				Con.Close();
			}
			context.Response.End();
		}

		public bool IsReusable
		{
			get { return true; }
		}
	}
}
