using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.Shop.Admin
{
	/// <summary>
	/// WriteProduct   Դϴ.
	/// </summary>
	public class WriteProduct : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtName;
		protected System.Web.UI.WebControls.TextBox txtPrice;
		protected System.Web.UI.WebControls.TextBox txtDCPercent;
		protected System.Web.UI.WebControls.CheckBox chkboxAbsence;
		protected System.Web.UI.WebControls.TextBox txtDescription;
		protected System.Web.UI.WebControls.Button btnWrite;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileImageS;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileImageM;
		protected System.Web.UI.WebControls.TextBox txtWeight;
		protected System.Web.UI.WebControls.TextBox txtStone;
		protected System.Web.UI.WebControls.DropDownList drpdnlstBrand;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileImageL;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				this.ViewState["returnUri"] = Request.UrlReferrer.AbsoluteUri;

				PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
				drpdnlstBrand.DataSource = db.GetBrandList();
				drpdnlstBrand.DataTextField = "Name";
				drpdnlstBrand.DataValueField = "ID";
				drpdnlstBrand.DataBind();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnWrite.Click += new System.EventHandler(this.btnWrite_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnWrite_Click(object sender, System.EventArgs e)
		{
			int price;
			int dcPercent;
			try
			{
				price = Convert.ToInt32(txtPrice.Text);
				dcPercent = Convert.ToInt32(txtDCPercent.Text);
			}
			catch
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ԷϽ  ùٸ Ƚϴ.");
				return;
			}

			if (dcPercent > 100)
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ԷϽ  ùٸ Ƚϴ.");
				return;
			}

			int indexId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["indexId"], -1);

			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			int result = db.AddProduct(indexId, txtName.Text, txtDescription.Text, price, dcPercent, 
				chkboxAbsence.Checked, fileImageS.PostedFile, fileImageM.PostedFile, 
				fileImageL.PostedFile, Convert.ToInt32(drpdnlstBrand.SelectedItem.Value),
				Convert.ToInt32(txtWeight.Text), txtStone.Text);
			if (result == -2)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("JPEG ϸ ε  ֽϴ.");
			else if (result == -1)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" !");
			else
			{
				int topId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["topId"], -1);
				string redirUri = this.ViewState["returnUri"].ToString();
				if (redirUri.IndexOf("topId=") == -1)
				{
					if (redirUri.IndexOf("?") == -1)
						redirUri += "?topId=" + topId;
					else
						redirUri += "&topId=" + topId;
				}
				if (redirUri.IndexOf("indexId=") == -1)
				{
					if (redirUri.IndexOf("?") == -1)
						redirUri += "?indexId=" + indexId;
					else
						redirUri += "&indexId=" + indexId;
				}

				Response.Redirect(redirUri);
			}
		}
	}
}
