namespace PowerOfDotNet.Shop
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;

	/// <summary>
	///		ShopLeftMenu   Դϴ.
	/// </summary>
	public abstract class ShopLeftMenu : PowerOfDotNet.PortalModuleControl
	{
		protected System.Web.UI.WebControls.Repeater reptTop;

		private PowerOfDotNet.Components.ShopDB _db;
		private int _no = 0;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			_db = new PowerOfDotNet.Components.ShopDB();
			reptTop.DataSource = CreateTopDataSource();
			reptTop.DataBind();

			string topCategoryMenuCountReplaceScript = @"
<script language=""JavaScript"">
<!--
	topCategoryMenuCount = {0};
//-->
</script>
			";

			topCategoryMenuCountReplaceScript = String.Format(topCategoryMenuCountReplaceScript, _no);
			this.Page.RegisterStartupScript("topCategoryMenuCountReplaceScript", topCategoryMenuCountReplaceScript);
		}

		private ICollection CreateTopDataSource() 
		{
			DataTable dt = new DataTable();
			DataRow dr;
 
			dt.Columns.Add(new DataColumn("ID", typeof(int)));
			dt.Columns.Add(new DataColumn("Name", typeof(string)));
			dt.Columns.Add(new DataColumn("ImageNameMenu", typeof(string)));
			dt.Columns.Add(new DataColumn("No", typeof(int)));

			SqlDataReader drTop = _db.GetCategoryTopList();
 
			while (drTop.Read())
			{
				dr = dt.NewRow();

				dr[0] = drTop["ID"];
				dr[1] = drTop["Name"].ToString();
				dr[2] = drTop["ImageNameMenu"].ToString();
				dr[3] = ++_no;

				dt.Rows.Add(dr);
			}

			DataView dv = new DataView(dt);
			return dv;
		}


		private ICollection CreateIndexDataSource(int topId) 
		{
			DataTable dt = new DataTable();
			DataRow dr;
 
			dt.Columns.Add(new DataColumn("ID", typeof(int)));
			dt.Columns.Add(new DataColumn("Name", typeof(string)));
			dt.Columns.Add(new DataColumn("ImageNameMenu", typeof(string)));

			SqlDataReader drTop = _db.GetCategoryIndexList(topId);
 
			while (drTop.Read())
			{
				dr = dt.NewRow();

				dr[0] = drTop["ID"];
				dr[1] = drTop["Name"].ToString();
				dr[2] = drTop["ImageNameMenu"].ToString();

				dt.Rows.Add(dr);
			}

			DataView dv = new DataView(dt);
			return dv;
		}

		protected string GetProdListLink(int indexId)
		{
			return GetLink("īǰ") + "&indexId=" + indexId;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.reptTop.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.reptTop_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void reptTop_ItemDataBound(object sender, System.Web.UI.WebControls.RepeaterItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				int id = (int)((DataRowView)e.Item.DataItem)["ID"];
				SqlDataReader dr = _db.GetCategoryIndexList(id);
				Repeater reptCategoryIndex = (Repeater)e.Item.FindControl("reptCategoryIndex");
				reptCategoryIndex.DataSource = CreateIndexDataSource(id);
				reptCategoryIndex.DataBind();
			}
		}
	}
}
