using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Configuration;

namespace PowerOfDotNet.Clubs
{
	/// <summary>
	/// UserJoin   Դϴ.
	/// </summary>
	public class UserJoin : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSelfIntroduction;
		protected System.Web.UI.WebControls.Label lblClubSubject;
		protected System.Web.UI.WebControls.Label lblUserName;
		protected System.Web.UI.WebControls.Button btnJoin;
		protected System.Web.UI.WebControls.CheckBoxList chkboxlstOpenInfo;

		private int _clubId;

		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			if (!IsPostBack)
			{
				string userId = this.Page.User.Identity.Name;
				PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
				SqlDataReader dr = db.GetClubUserInfo(_clubId, userId);
				if (dr.Read())
				{
					//̹ ԵǾ
					MyWebLibs.Utilities.CommonMethods.PrintMsgAndClose("̹ ϼ̽ϴ.");
					return;
				}
				dr.Close();

				lblUserName.Text = Request.Cookies["usersInfo"]["Name"].ToString();
				SqlDataReader drClub = db.GetClub(_clubId);
				drClub.Read();
				lblClubSubject.Text = drClub["Subject"].ToString();
				this.ViewState["PublicType"] = (byte)drClub["PublicType"];
				drClub.Close();

				string[] aOpenInfos = ConfigurationSettings.AppSettings["ClubUserOpenInformations"].Split(new char[] {';'});

				foreach (string opName in aOpenInfos)
				{
					string[] aFieldInfo = opName.Split(new char[] {'='});
					ListItem item = new ListItem(aFieldInfo[0]);
					chkboxlstOpenInfo.Items.Add(item);
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnJoin.Click += new System.EventHandler(this.btnJoin_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnJoin_Click(object sender, System.EventArgs e)
		{
			string openInfo = String.Empty;
			foreach (ListItem item in chkboxlstOpenInfo.Items)
			{
				if (item.Selected)
				{
					if (openInfo == String.Empty)
						openInfo += item.Text;
					else
						openInfo += ";" + item.Text;
				}
			}

			byte publicType = (byte)this.ViewState["PublicType"];
			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			int result = db.JoinClubUser(_clubId, this.Page.User.Identity.Name, txtSelfIntroduction.Text, openInfo, publicType);
			if (result != -1)
			{
				if (publicType == 2)
					MyWebLibs.Utilities.CommonMethods.PrintMsgAndCloseAndOpenerReload(" ȣȸ̹Ƿ  ̿ մϴ.\\n" +
						"5Ͼȿ û   ڵ ˴ϴ.");
				else
				{
					string casheKey = "objClub_" + _clubId;
					MyWebLibs.Utilities.CommonMethods.RemoveObjectCache(casheKey);
					MyWebLibs.Utilities.CommonMethods.PrintMsgAndCloseAndOpenerReload("ԵǾϴ.");
				}
			}
			else
				MyWebLibs.Utilities.CommonMethods.PrintMsgAndClose("   ߽ϴ..");
		}
	}
}
