/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Clubs
{
	using System;
	using System.IO;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Configuration;
	using System.Collections;

	/// <summary>
	///		ClubMangement   Դϴ.
	/// </summary>
	public abstract class ClubMangement : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.Label lblSysop;
		protected System.Web.UI.WebControls.Label lblCreatedDate;
		protected System.Web.UI.WebControls.DropDownList drpdnlstClass;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstType;
		protected System.Web.UI.WebControls.TextBox txtBoardSubject01;
		protected System.Web.UI.WebControls.TextBox txtBoardSubject02;
		protected System.Web.UI.WebControls.TextBox txtBoardSubject03;
		protected System.Web.UI.WebControls.TextBox txtBoardSubject04;
		protected System.Web.UI.WebControls.TextBox txtBoardSubject05;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstBoardType01;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstBoardType02;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstBoardType03;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstBoardType04;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstBoardType05;
		protected System.Web.UI.WebControls.Button btnCommit;
		protected System.Web.UI.WebControls.TextBox txtClubSubject;
		protected System.Web.UI.WebControls.TextBox txtClubIntorduction;
		protected System.Web.UI.WebControls.TextBox txtClubSkin;
		protected System.Web.UI.WebControls.TextBox txtViceSysops;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstSkinType;
		protected System.Web.UI.WebControls.TextBox txtSysopID;
		protected System.Web.UI.WebControls.ListBox lstboxClubFiles;
		protected System.Web.UI.WebControls.Button btnFileUpload;
		protected System.Web.UI.WebControls.Button btnFileDelete;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileForUpload;
		protected System.Web.UI.WebControls.LinkButton lnkbtnRemoveClub;

		protected int _clubId;


		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);

			if (!this.IsPostBack)
			{
				Components.ClubInfo clubInfo = ClubsUtil.GetClubInfo(this, _clubId);

				txtClubSubject.Text = clubInfo.subject;
				lblSysop.Text = clubInfo.sysopName + "(" +clubInfo.sysopId + ")";
				lblCreatedDate.Text = clubInfo.CreatedDate.ToString("yyyy MM dd");
				txtClubIntorduction.Text = clubInfo.introHtml;
				rdobtnlstType.SelectedIndex = (int)clubInfo.publicType;
				txtViceSysops.Text = clubInfo.viceSysopId;
				txtClubSkin.Text = clubInfo.mainHtml;

				PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
				SqlDataReader drClubClass = db.GetClubsClass();
				drpdnlstClass.DataSource = drClubClass;
				drpdnlstClass.DataTextField = "Name";
				drpdnlstClass.DataValueField = "ID";
				drpdnlstClass.DataBind();
				foreach (ListItem item in drpdnlstClass.Items) {
					if (Convert.ToInt32(item.Value) == clubInfo.classId) {
						item.Selected = true;
						break;
					}
				}

				Hashtable htBoardId = new Hashtable();
				SqlDataReader drBoardList = db.GetBoardList(_clubId);
				drBoardList.Read();
				txtBoardSubject01.Text = drBoardList["Subject"].ToString();
				rdobtnlstBoardType01.SelectedIndex = (int)(byte)drBoardList["Type"];
				htBoardId.Add("txtBoardSubject01",(int)drBoardList["ID"]);
				drBoardList.Read();
				txtBoardSubject02.Text = drBoardList["Subject"].ToString();
				rdobtnlstBoardType02.SelectedIndex = (int)(byte)drBoardList["Type"];
				htBoardId.Add("txtBoardSubject02",(int)drBoardList["ID"]);
				drBoardList.Read();
				txtBoardSubject03.Text = drBoardList["Subject"].ToString();
				rdobtnlstBoardType03.SelectedIndex = (int)(byte)drBoardList["Type"];
				htBoardId.Add("txtBoardSubject03",(int)drBoardList["ID"]);
				drBoardList.Read();
				txtBoardSubject04.Text = drBoardList["Subject"].ToString();
				rdobtnlstBoardType04.SelectedIndex = (int)(byte)drBoardList["Type"];
				htBoardId.Add("txtBoardSubject04",(int)drBoardList["ID"]);
				drBoardList.Read();
				txtBoardSubject05.Text = drBoardList["Subject"].ToString();
				rdobtnlstBoardType05.SelectedIndex = (int)(byte)drBoardList["Type"];
				htBoardId.Add("txtBoardSubject05",(int)drBoardList["ID"]);
				drBoardList.Close();

				this.ViewState["boardIdList"] = htBoardId;

				if ((int)clubInfo.skinType == 0)
					rdobtnlstSkinType.Items[0].Selected = true;

				//⺻ Ų Web.Config Ѵ.
				//⺻ Ų ټ 谡 .
				string[] aSkins = ConfigurationSettings.AppSettings["ClubSkinTypes"].Split(new char[] {';'});
				int i = 1;
				foreach (string skinInfo in aSkins) {
					string[] aSkinInfo = skinInfo.Split(new char[] {'='});
					ListItem item = new ListItem(aSkinInfo[0], i.ToString());
					if (i++ == (int)clubInfo.skinType)
						item.Selected = true;
					rdobtnlstSkinType.Items.Add(item);
				}

				txtSysopID.Text = clubInfo.sysopId;
				
				string filePath = this.Page.MapPath("/Clubs/ClubsDir/clubId_" + _clubId + "/");
				if (!Directory.Exists(filePath))
					Directory.CreateDirectory(filePath);
				string [] fileEntries = Directory.GetFiles(filePath);

				foreach (string fileP in fileEntries) {
					string fileName = fileP.Substring(fileP.LastIndexOf(@"\") + 1);
					lstboxClubFiles.Items.Add(new ListItem(fileName, fileP));	
				}

				this.Form.Enctype = "multipart/form-data";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnCommit.Click += new System.EventHandler(this.btnCommit_Click);
			this.btnFileUpload.Click += new System.EventHandler(this.btnFileUpload_Click);
			this.btnFileDelete.Click += new System.EventHandler(this.btnFileDelete_Click);
			this.lnkbtnRemoveClub.Click += new System.EventHandler(this.lnkbtnRemoveClub_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnCommit_Click(object sender, System.EventArgs e)
		{
			string casheKey = "objClub_" + _clubId;
			//PowerOfDotNet.Components.ClubInfo clubInfo = (PowerOfDotNet.Components.ClubInfo)this.GetObjectFromCache(casheKey);
			Components.ClubInfo clubInfo = ClubsUtil.GetClubInfo(this, _clubId);

			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			db.UpdateClub(_clubId, txtClubSubject.Text, clubInfo.classId, 
				(byte)rdobtnlstType.SelectedIndex, txtSysopID.Text, txtViceSysops.Text, 
				txtClubIntorduction.Text, txtClubSkin.Text, (byte)rdobtnlstSkinType.SelectedIndex);

			Hashtable htBoardId = (Hashtable)this.ViewState["boardIdList"];

			db.UpdateBoardNameAndType((int)htBoardId["txtBoardSubject01"], txtBoardSubject01.Text, (byte)rdobtnlstBoardType01.SelectedIndex);
			db.UpdateBoardNameAndType((int)htBoardId["txtBoardSubject02"], txtBoardSubject02.Text, (byte)rdobtnlstBoardType02.SelectedIndex);
			db.UpdateBoardNameAndType((int)htBoardId["txtBoardSubject03"], txtBoardSubject03.Text, (byte)rdobtnlstBoardType03.SelectedIndex);
			db.UpdateBoardNameAndType((int)htBoardId["txtBoardSubject04"], txtBoardSubject04.Text, (byte)rdobtnlstBoardType04.SelectedIndex);
			db.UpdateBoardNameAndType((int)htBoardId["txtBoardSubject05"], txtBoardSubject05.Text, (byte)rdobtnlstBoardType05.SelectedIndex);

			//Ŭ  ŵǾǷ
			this.RemoveObjectCache(casheKey);
			SqlDataReader dr = db.GetBoardList(_clubId);
			while (dr.Read()) {
				int id = dr.GetInt32(0);
				this.RemoveObjectCache("BoardClubTableInfo" + id);
			}
			dr.Close();

			Response.Redirect(GetLink("Ŭ"));
		}

		private void btnFileUpload_Click(object sender, System.EventArgs e)
		{
			string userId = this.Page.User.Identity.Name;

			string strFileName = fileForUpload.PostedFile.FileName;
			if (strFileName.Trim() == String.Empty)	{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ε  ϼ.");
				return;
			}

			int intFileNameStart = strFileName.LastIndexOf(@"\");
			if (intFileNameStart > 0)
				strFileName = strFileName.Substring(intFileNameStart+1);

			foreach (ListItem item in lstboxClubFiles.Items) {
				if (strFileName.ToLower() == item.Text.ToLower()) {
					MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" ̸   ΰ̻   ϴ.");
					return;
				}
			}

			//ε   ͸ Ѵ.
			string filePath = HttpContext.Current.Server.MapPath("/Clubs/ClubsDir/clubId_" + _clubId + "/");
			if (!Directory.Exists(filePath))
				Directory.CreateDirectory(filePath);

			fileForUpload.PostedFile.SaveAs(filePath + strFileName);
			lstboxClubFiles.Items.Add(new ListItem(strFileName, filePath + strFileName));
		}


		private void btnFileDelete_Click(object sender, System.EventArgs e)
		{
			//0 ̸ ƴ϶ 
			if (lstboxClubFiles.SelectedIndex >= 0)	{
				string userId = this.Page.User.Identity.Name;
				File.Delete(lstboxClubFiles.SelectedItem.Value);
				lstboxClubFiles.Items.RemoveAt(lstboxClubFiles.SelectedIndex);
			}
		}


		private void lnkbtnRemoveClub_Click(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			int result = db.RemoveClub(_clubId);
			if (result == -1)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("!");
			else
				MyWebLibs.Utilities.CommonMethods.PrintMsgRedirectTarget("Ŭ Ͽϴ.", GetLink("Ŭ"), "_self");
		}
	}
}
