/*
 * 2004 2 20 
 * */

using System;
using System.IO;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.Mail;
using System.Configuration;
using System.Text;

namespace PowerOfDotNet.Clubs
{
	/// <summary>
	/// SendMailToClubMember   Դϴ.
	/// </summary>
	public class SendMailToClubMember : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSubject;
		protected System.Web.UI.WebControls.TextBox txtMessage;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstFromat;
		protected System.Web.UI.WebControls.Label lblUploadedSize;
		protected System.Web.UI.WebControls.ListBox lstboxAttached;
		protected System.Web.UI.WebControls.Button btnFileAttach;
		protected System.Web.UI.WebControls.Button btnFileDelete;
		protected System.Web.UI.WebControls.CheckBox chkboxUseAvatar;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstAvatarExp;
		protected System.Web.UI.WebControls.CheckBox chkboxSaveSentBox;
		protected System.Web.UI.WebControls.Button btnSend;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileAttach;

		protected int _clubId;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			if (!IsPostBack)
			{
				PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
				SqlDataReader dr = db.GetClub(_clubId);
				dr.Read();
				string sysopId = dr["SysopID"].ToString();
				dr.Close();
				if (sysopId != this.Page.User.Identity.Name)
				{
					MyWebLibs.Utilities.CommonMethods.PrintMsgAndClose("û ̿ ִ  Դϴ.");
					return;
				}

				PowerOfDotNet.Components.AvatarDB dbAvatar = new PowerOfDotNet.Components.AvatarDB();
				SqlDataReader drAvatarExp = dbAvatar.GetAvatarExpression();
				rdobtnlstAvatarExp.DataSource = drAvatarExp;
				rdobtnlstAvatarExp.DataTextField = "Description";
				rdobtnlstAvatarExp.DataValueField = "ID";
				rdobtnlstAvatarExp.DataBind();

				btnFileAttach.Attributes["onclick"] = "AttachFileUploadCheck()";
				if (!this.Page.IsStartupScriptRegistered("_WriteMailAttachVarSetup"))
				{
					string writeMailAttachVarSetup = @"
<script language=javascript>
<!--
	fileAttach = document.getElementById('{0}');
	lstboxAttached = document.getElementById('{1}');
//-->
</script>
";
					writeMailAttachVarSetup = String.Format(writeMailAttachVarSetup, 
						fileAttach.ClientID, lstboxAttached.ClientID);
					this.Page.RegisterStartupScript("_WriteMailAttachVarSetup", writeMailAttachVarSetup);
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnFileAttach.Click += new System.EventHandler(this.btnFileAttach_Click);
			this.btnFileDelete.Click += new System.EventHandler(this.btnFileDelete_Click);
			this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnFileAttach_Click(object sender, System.EventArgs e)
		{
			if (lstboxAttached.Items.Count >= 11)
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ε ϼ 10  ϴ.");
				return;
			}

			string userId = this.Page.User.Identity.Name;
			string userDir = Request.Cookies["usersInfo"]["UserDir"].ToString();

			string strFileName = fileAttach.PostedFile.FileName;
			if (strFileName.Trim() == String.Empty)
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ε  ϼ.");
				return;
			}

			int intFileNameStart = strFileName.LastIndexOf(@"\");
			if (intFileNameStart > 0)
				strFileName = strFileName.Substring(intFileNameStart+1);

			foreach (ListItem item in lstboxAttached.Items)
			{
				if (strFileName.ToLower() == item.Text.ToLower())
				{
					MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" ̸   ΰ̻   ϴ.");
					return;
				}
			}

			//ε   ͸ Ѵ.
			string filePath = this.MapPath("/User/UserDir/" + userDir 
				+ "/" + userId + "/temp_file/");
			if (!Directory.Exists(filePath))
				Directory.CreateDirectory(filePath);

			//ʿ ϵ Ѵ.
			string [] fileEntries = Directory.GetFiles(filePath);
			foreach(string fileName in fileEntries)
			{
				//ε Ϸ̻   Ѵ.
				if (DateTime.Now.AddDays(-1) > File.GetLastWriteTime(fileName))
					File.Delete(fileName);
			}

			int selectedFileTotalSize = 0;
			foreach (ListItem item in lstboxAttached.Items)
			{
				try {
					selectedFileTotalSize += Convert.ToInt32(item.Value);
				}
				catch
				{
				}
			}

			lblUploadedSize.Text = ((fileAttach.PostedFile.ContentLength + selectedFileTotalSize) / 1024).ToString();
			fileAttach.PostedFile.SaveAs(filePath + strFileName);
			lstboxAttached.Items.Add(new ListItem(strFileName, fileAttach.PostedFile.ContentLength.ToString()));
		}

		private void btnFileDelete_Click(object sender, System.EventArgs e)
		{
			//0 ̸ ƴ϶ 
			if (lstboxAttached.SelectedIndex > 0)
			{
				string userId = this.Page.User.Identity.Name;
				string userDir = Request.Cookies["usersInfo"]["UserDir"].ToString();
				string filePath = this.MapPath("/User/UserDir/" + userDir 
					+ "/" + userId + "/temp_file/");
				//File.Delete(filePath + lstboxAttached.SelectedItem.Value);
				File.Delete(filePath + lstboxAttached.SelectedItem.Text);
				lstboxAttached.Items.RemoveAt(lstboxAttached.SelectedIndex);
			}
		}

		private void btnSend_Click(object sender, System.EventArgs e)
		{
			string message;
			if (rdobtnlstFromat.SelectedIndex == 0)
				message = Server.HtmlEncode(txtMessage.Text).Replace("\n", "<br>");
			else
				message = txtMessage.Text;

			string userId = this.Page.User.Identity.Name;
			string myAddr = Request.Cookies["usersInfo"]["Name"].ToString() + " <" + userId + "@" + ConfigurationSettings.AppSettings["DomainName"] + ">";
			string userDir = Request.Cookies["usersInfo"]["UserDir"].ToString();

			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			DataSet ds = db.GetClubUserList(_clubId);
			foreach (DataRowView drv in ds.Tables[0].DefaultView)
			{
				string toAddr;

				string memberEmail = drv["Email"].ToString().Trim();
				string memberName = drv["Name"].ToString();
				string memberID = drv["UserID"].ToString().Trim();

				if (memberID == userId)
					continue;

				if (memberEmail == String.Empty)
					memberEmail = memberID + "@" + ConfigurationSettings.AppSettings["DomainName"];

				toAddr = memberName + " <" + memberEmail + ">";

				MailMessage mail = new MailMessage();
				mail.From = myAddr;
				mail.To = toAddr;
				mail.Cc = "";
				mail.Bcc = "";
				mail.Subject = txtSubject.Text;

				if (chkboxUseAvatar.Checked)
					mail.Body = message + "<br>" + AddAvatarToMailBody(rdobtnlstAvatarExp.SelectedIndex);
				else
					mail.Body = message;

				mail.BodyFormat = MailFormat.Html;
				string filePath = this.MapPath("/User/UserDir/" + userDir 
					+ "/" + userId + "/temp_file/");
				string attachedFiles = String.Empty;
				for (int i=1; i<lstboxAttached.Items.Count; i++)
				{
					string file = lstboxAttached.Items[i].Text;
					mail.Attachments.Add(new MailAttachment(filePath + file));
					if (attachedFiles == String.Empty)
						attachedFiles += file + "," + lstboxAttached.Items[i].Value;
					else
						attachedFiles += ";" + file + "," + lstboxAttached.Items[i].Value;
				}
			
				string smtpServer = ConfigurationSettings.AppSettings["SmtpServer"];
				SmtpMail.SmtpServer = smtpServer; 

				SmtpMail.Send(mail);
			}

		}

		private string AddAvatarToMailBody(int expression)
		{
			if (!Request.IsAuthenticated) return String.Empty;

			string userId = this.Page.User.Identity.Name;

			string senderAddress = "http://" + ConfigurationSettings.AppSettings["DomainName"];
			string templateHead = @"
				<table cellSpacing=""0"" cellPadding=""0""  border=""0"" >
					<tr>
						<td align=""middle""  id=""cellInner"" runat=""server"">
							<DIV id=""character"" style=""OVERFLOW: hidden; WIDTH: 100%; HEIGHT: 100%""><IMG id=""blankImage"" src=""{0}/Avatar/images/blank.gif"" align=""absMiddle"" border=""0"">
					";

			string templateContent = @"
				<DIV STYLE='position:absolute; left:0; top:0; z-index:{1}'>
				<img id=layerimgl1 src='{0}{2}' border=0 align=absmiddle></DIV>
					";

			string templateTail = @"
							</DIV>
						</td>
					</tr>
				</table>
				";

			StringBuilder avatarBuilder = new StringBuilder();
			avatarBuilder.Append("\n\n"); 
			avatarBuilder.Append(String.Format(templateHead, senderAddress) + "\n");

			PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();

			SqlDataReader dr = db.GetUserAvater(userId);
			bool dataEmpty = true;

			while (dr.Read())
			{
				string content = String.Format(templateContent,senderAddress, 
					dr["LayerNum"].ToString(), dr["ImageName"].ToString());
				avatarBuilder.Append(content + "\n");
				dataEmpty = false;
			}
			dr.Close();

			//  ƹŸ  
			if (dataEmpty)
			{
				dr = db.GetDefaultAvatar();
				while (dr.Read())
				{
					string content = String.Format(templateContent,senderAddress, 
						dr["LayerNum"].ToString(), dr["ImageName"].ToString());
					avatarBuilder.Append(content + "\n");
				}
				dr.Close();
			}

			if (expression != 0)
			{
				SqlDataReader drExp = db.GetAvatarExpressionItem(expression);
				if (drExp.Read())
				{
					string content = String.Format(templateContent,senderAddress, 
						drExp["LayerNum"].ToString(), drExp["ImageName"].ToString());
					avatarBuilder.Append(content + "\n");
				}
				drExp.Close();
			}

			avatarBuilder.Append(templateTail + "\n");

			return avatarBuilder.ToString();
		}
	}
}
