/*
 * 2004 2 20 
 * */

using System;
using System.Web;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;

namespace PowerOfDotNet.Components
{
	public class BoardLactureData
	{
		public int ID;
		public int GroupID;
		public string Subject;
		public string Writer;
		public string Email;
		public string Content;
		public string Password;
		public string UserIP;
		public string UserID;
		public byte Format;
		public byte FileCount;
		public bool UseAvatar;
		public byte AvatarExpression;
	}

	public class BoardLactureInfo
	{
		public int BBSID;
		public string BBSSubject;
		public string BBSTable;
		public string BBSHtml;
		public string BBSImage;
		public byte BBSDisplayType;
		public string BBSRoles;
		public string BBSImageHeadName;
		public string BBSCssClassHead;
		public string BBSMessage;
		public string BBSMsgContent;
		public bool BBSMsgDisplay;
		public byte BBSType; //0-Ϲ, 1-
		public string BBSPageNameList;
		public string BBSPageNameWrite;
		public string BBSPageNameEdit;
		public string BBSPageNameReply;
		public string BBSPageNameContent;
	}

	/// <summary>
	/// BoardLactureDB   Դϴ.
	/// </summary>
	public class BoardLactureDB
	{
		public SqlDataReader GetBoardAllInfo()
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand getTablenameCmd = new SqlCommand("SP_LACTURE_GET_ALL_BOARD_INFO", myConnection);

			getTablenameCmd.CommandType = CommandType.StoredProcedure;

			myConnection.Open();
			SqlDataReader dr = getTablenameCmd.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public int GetBoardIdBySubject(string bbsSubject)
		{
			string sql = "select BBSID from BBSInfo where BBSSubject='" + bbsSubject + "'";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			int ret = -1;
			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader();
			if (dr.Read())
				ret = dr.GetInt32(0);

			dr.Close();
			myConnection.Close();

			return ret;
		}

		public BoardLactureInfo GetBoardInfo(int boardId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand getTablenameCmd = new SqlCommand("SP_LACTURE_GET_BOARD_INFO", myConnection);

			getTablenameCmd.CommandType = CommandType.StoredProcedure;

			SqlParameter parameterBoardID = new SqlParameter("@BoardID", SqlDbType.Int);
			parameterBoardID.Value = boardId;
			getTablenameCmd.Parameters.Add(parameterBoardID);

			myConnection.Open();
			SqlDataReader dr = getTablenameCmd.ExecuteReader();
			dr.Read();
			BoardLactureInfo blinfo= new BoardLactureInfo();
			blinfo.BBSID = (int)dr["BBSID"];
			blinfo.BBSSubject = (string)dr["BBSSubject"];
			blinfo.BBSTable = (string)dr["BBSTable"];
			blinfo.BBSHtml = (string)dr["BBSHtml"];
			blinfo.BBSDisplayType = (byte)dr["BBSDisplayType"];
			blinfo.BBSImage = (string)dr["BBSImage"];
			blinfo.BBSRoles = (string)dr["BBSRoles"];
			blinfo.BBSImageHeadName = (string)dr["BBSImageHeadName"];
			blinfo.BBSCssClassHead = (string)dr["BBSCssClassHead"];
			blinfo.BBSMessage = (string)dr["BBSMessage"];
			blinfo.BBSMsgContent = (string)dr["BBSMsgContent"];
			blinfo.BBSMsgDisplay = (bool)dr["BBSMsgDisplay"];
			blinfo.BBSType = (byte)dr["BBSType"];
			blinfo.BBSPageNameContent = (string)dr["BBSPageNameContent"];
			blinfo.BBSPageNameEdit = (string)dr["BBSPageNameEdit"];
			blinfo.BBSPageNameList = (string)dr["BBSPageNameList"];
			blinfo.BBSPageNameReply = (string)dr["BBSPageNameReply"];
			blinfo.BBSPageNameWrite = (string)dr["BBSPageNameWrite"];

			dr.Close();
			myConnection.Close();

			return blinfo;

		}

		public int UpdateBBSInfo(BoardLactureInfo blInfo)
		{

			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("UpdateBBSInfo", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;

			myCommand.Parameters.Add(new SqlParameter("@BoardID", SqlDbType.Int, 4)).Value = blInfo.BBSID;
			myCommand.Parameters.Add(new SqlParameter("@BBSSubject", SqlDbType.NVarChar, 50)).Value = blInfo.BBSSubject;
			myCommand.Parameters.Add(new SqlParameter("@BBSTable", SqlDbType.NVarChar, 50)).Value = blInfo.BBSTable;
			myCommand.Parameters.Add(new SqlParameter("@BBSHtml", SqlDbType.NText)).Value = blInfo.BBSHtml;
			myCommand.Parameters.Add(new SqlParameter("@BBSDisplayType", SqlDbType.TinyInt)).Value = blInfo.BBSDisplayType;
			myCommand.Parameters.Add(new SqlParameter("@BBSImage", SqlDbType.VarChar, 80)).Value = blInfo.BBSImage;
			myCommand.Parameters.Add(new SqlParameter("@BBSRoles", SqlDbType.NVarChar, 50)).Value = blInfo.BBSRoles;
			myCommand.Parameters.Add(new SqlParameter("@BBSImageHeadName", SqlDbType.VarChar, 40)).Value = blInfo.BBSImageHeadName;
			myCommand.Parameters.Add(new SqlParameter("@BBSCssClassHead", SqlDbType.VarChar, 20)).Value = blInfo.BBSCssClassHead;
			myCommand.Parameters.Add(new SqlParameter("@BBSMessage", SqlDbType.NVarChar, 50)).Value = blInfo.BBSMessage;
			myCommand.Parameters.Add(new SqlParameter("@BBSMsgContent", SqlDbType.NVarChar, 50)).Value = blInfo.BBSMsgContent;
			myCommand.Parameters.Add(new SqlParameter("@BBSMsgDisplay", SqlDbType.Bit)).Value = blInfo.BBSMsgDisplay;
			myCommand.Parameters.Add(new SqlParameter("@BBSType", SqlDbType.TinyInt)).Value = blInfo.BBSType;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameContent", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameContent;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameEdit", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameEdit;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameList", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameList;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameReply", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameReply;
			myCommand.Parameters.Add(new SqlParameter("@BBSPageNameWrite", SqlDbType.NVarChar, 50)).Value = blInfo.BBSPageNameWrite;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();

			return Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value);
		}


		public SqlDataReader GetSqlRecentSubject(string tableName, int topCount)
		{
			//string sql = "select top " + topCount + " ID, Subject, Writer, GroupID, TreeID, RegDate, Content from " + tableName + " order by [Order] desc";
			//SP_LACTURE_GET_Recent_List
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_LACTURE_GET_Recent_List", myConnection);
			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			myCommand.Parameters.Add(new SqlParameter("@TopCount", SqlDbType.Char, 3)).Value = topCount;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetList(string tableName, int intPage, int intRowCount, out int intRecCount, out int intPageCount)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			
			/*
			SqlCommand getTablenameCmd = new SqlCommand("SP_LACTURE_GET_BOARD_TABLE_NAME", myConnection);

			getTablenameCmd.CommandType = CommandType.StoredProcedure;

			SqlParameter parameterBoardID = new SqlParameter("@BoardID", SqlDbType.Int);
			parameterBoardID.Value = boardId;
			getTablenameCmd.Parameters.Add(parameterBoardID);

			SqlParameter parameterTableName = new SqlParameter("@TableName", SqlDbType.NVarChar, 50);
			parameterTableName.Direction = ParameterDirection.Output;
			getTablenameCmd.Parameters.Add(parameterTableName);

			myConnection.Open();
			getTablenameCmd.ExecuteNonQuery();
			*/

			SqlCommand myCommand = new SqlCommand("SP_LACTURE_BOARD_LIST_COUNT", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PAGE", SqlDbType.Int, 4)).Value = intPage;

			myCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.Parameters["@ROW_COUNT"].Direction = ParameterDirection.InputOutput;

			SqlParameter parameterAscCount = new SqlParameter("@ASC_Count", SqlDbType.Int);
			parameterAscCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterAscCount);

			SqlParameter parameterRecCount = new SqlParameter("@RecCount", SqlDbType.Int);
			parameterRecCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterRecCount);

			SqlParameter parameterPageCount = new SqlParameter("@PageCount", SqlDbType.Int);
			parameterPageCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterPageCount);

			SqlParameter parameterTableName2 = new SqlParameter("@TableName", SqlDbType.NVarChar);
			parameterTableName2.Value = tableName;
			myCommand.Parameters.Add(parameterTableName2);

			myConnection.Open();
			myCommand.ExecuteNonQuery();

			intRowCount = (int)myCommand.Parameters["@ROW_COUNT"].Value;
			int ascCount = (int)parameterAscCount.Value;
			intRecCount = (int)parameterRecCount.Value;
			intPageCount = (int)parameterPageCount.Value;
			
			myCommand = new SqlCommand("SP_LACTURE_BOARD_LIST", myConnection);
			myCommand.CommandType = CommandType.StoredProcedure;
			myCommand.Parameters.Add(new SqlParameter("@ASC_COUNT", SqlDbType.Int, 4)).Value = ascCount;
			myCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			//dr.Close();

			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetListWithWhere(string tableName, int intPage, int intRowCount, string where, out int intRecCount, out int intPageCount)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);

			/*
			SqlCommand getTablenameCmd = new SqlCommand("SP_LACTURE_GET_BOARD_TABLE_NAME", myConnection);

			SqlParameter parameterBoardID = new SqlParameter("@BoardID", SqlDbType.Int);
			parameterBoardID.Value = boardId;
			getTablenameCmd.Parameters.Add(parameterBoardID);

			SqlParameter parameterTableName = new SqlParameter("@TableName", SqlDbType.NVarChar, 50);
			parameterTableName.Direction = ParameterDirection.Output;
			getTablenameCmd.Parameters.Add(parameterTableName);

			myConnection.Open();
			getTablenameCmd.ExecuteNonQuery();
			*/

			SqlCommand myCommand = new SqlCommand("SP_LACTURE_BOARD_LIST_WITH_WHERE_COUNT", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PAGE", SqlDbType.Int, 4)).Value = intPage;

			myCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.Parameters["@ROW_COUNT"].Direction = ParameterDirection.InputOutput;

			SqlParameter parameterAscCount = new SqlParameter("@ASC_Count", SqlDbType.Int);
			parameterAscCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterAscCount);

			SqlParameter parameterRecCount = new SqlParameter("@RecCount", SqlDbType.Int);
			parameterRecCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterRecCount);

			SqlParameter parameterPageCount = new SqlParameter("@PageCount", SqlDbType.Int);
			parameterPageCount.Direction = ParameterDirection.Output;
			myCommand.Parameters.Add(parameterPageCount);

			SqlParameter parameterPageCountWhere = new SqlParameter("@Where", SqlDbType.NVarChar, 200);
			parameterPageCountWhere.Value = where;
			myCommand.Parameters.Add(parameterPageCountWhere);

			SqlParameter parameterTableName2 = new SqlParameter("@TableName", SqlDbType.NVarChar);
			parameterTableName2.Value = tableName;
			myCommand.Parameters.Add(parameterTableName2);

			myConnection.Open();
			myCommand.ExecuteNonQuery();

			intRowCount = (int)myCommand.Parameters["@ROW_COUNT"].Value;
			int ascCount = (int)parameterAscCount.Value;
			intRecCount = (int)parameterRecCount.Value;
			intPageCount = (int)parameterPageCount.Value;
			
			myCommand = new SqlCommand("SP_LACTURE_BOARD_LIST_WITH_WHERE", myConnection);
			myCommand.CommandType = CommandType.StoredProcedure;
			myCommand.Parameters.Add(new SqlParameter("@ASC_COUNT", SqlDbType.Int, 4)).Value = ascCount;
			myCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.Parameters.Add(new SqlParameter("@WHERE_CLAUSE", SqlDbType.NVarChar, 200)).Value = where;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}


		public SqlDataReader GetListByGroupID(string tableName, int GroupID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_LACTURE_BOARD_LIST_BY_GroupID", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@GroupID", SqlDbType.Int, 4)).Value = GroupID;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetContent(string tableName, int intID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_LACTURE_GET_CONTENT", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = intID;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetFileInfo(string tableName, int intID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_LACTURE_GET_FILEINFO", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = intID;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public void AddNew(string tableName, BoardLactureData oData, HttpFileCollection UploadFiles)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand bbsCommand = new SqlCommand("SP_LACTURE_ADD_ROW", myConnection);

			bbsCommand.CommandType = CommandType.StoredProcedure;
			bbsCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			bbsCommand.Parameters.Add(new SqlParameter("@SUBJECT", SqlDbType.VarChar, 100)).Value = oData.Subject;
			bbsCommand.Parameters.Add(new SqlParameter("@WRITER", SqlDbType.NVarChar, 20)).Value = oData.Writer;
			bbsCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.NVarChar, 12)).Value = oData.UserID;
			bbsCommand.Parameters.Add(new SqlParameter("@EMAIL", SqlDbType.VarChar, 40)).Value = oData.Email;
			bbsCommand.Parameters.Add(new SqlParameter("@CONTENT", SqlDbType.Text)).Value = oData.Content;
			bbsCommand.Parameters.Add(new SqlParameter("@PASSWORD", SqlDbType.VarChar, 12)).Value = oData.Password;
			bbsCommand.Parameters.Add(new SqlParameter("@USERIP", SqlDbType.VarChar, 20)).Value = oData.UserIP;
			bbsCommand.Parameters.Add(new SqlParameter("@FORMAT", SqlDbType.TinyInt, 1)).Value = oData.Format;
			bbsCommand.Parameters.Add(new SqlParameter("@UseAvatar", SqlDbType.Bit)).Value = oData.UseAvatar;
			bbsCommand.Parameters.Add(new SqlParameter("@AvatarExpression", SqlDbType.TinyInt, 1)).Value = oData.AvatarExpression;

			bbsCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			int fileCount = 0;
			//   ϱ ̴.
			for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
			{
				HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
				String strFileName = Path.GetFileName(_postedFile.FileName);
				if (strFileName != "") fileCount++;
			}
			bbsCommand.Parameters.Add(new SqlParameter("@FILECOUNT", SqlDbType.TinyInt, 1)).Value = fileCount;

			myConnection.Open();

			string sqlInsertFile = "insert into " + tableName + "Files (blfPID,blfFileName,blfSize,blfContent) ";
			sqlInsertFile += "VALUES (@ID, @FileName, @Size, @Content)";

			SqlCommand bbsFileCommand = new SqlCommand(sqlInsertFile, myConnection);

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			bbsCommand.Transaction = stTrans;
			bbsFileCommand.Transaction = stTrans;

			try
			{
				bbsCommand.ExecuteNonQuery();

				for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
				{
					HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
					String strFileName = Path.GetFileName(_postedFile.FileName);

					if (strFileName == "") continue;

					int intSize = _postedFile.ContentLength;
					System.Byte[] FileByteArray = new System.Byte[intSize];
					Stream StreamObj = _postedFile.InputStream;
					StreamObj.Read(FileByteArray,0,intSize);

					bbsFileCommand.Parameters.Clear();
					bbsFileCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = Convert.ToInt32(bbsCommand.Parameters["RETURN_VALUE"].Value);
					bbsFileCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.BigInt)).Value = intSize;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Content", SqlDbType.Image)).Value = FileByteArray;

					bbsFileCommand.ExecuteNonQuery();
				}

				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}
		}

		public void Modify(string tableName, BoardLactureData oData, HttpFileCollection UploadFiles, bool bPreserve)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand bbsCommand = new SqlCommand("SP_LACTURE_MODIFY_ROW", myConnection);

			bbsCommand.CommandType = CommandType.StoredProcedure;
			bbsCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = oData.ID;
			bbsCommand.Parameters.Add(new SqlParameter("@SUBJECT", SqlDbType.VarChar, 100)).Value = oData.Subject;
			//bbsCommand.Parameters.Add(new SqlParameter("@WRITER", SqlDbType.VarChar, 20)).Value = oData.Writer;
			//bbsCommand.Parameters.Add(new SqlParameter("@EMAIL", SqlDbType.VarChar, 40)).Value = oData.Email;
			bbsCommand.Parameters.Add(new SqlParameter("@CONTENT", SqlDbType.Text)).Value = oData.Content;
			//bbsCommand.Parameters.Add(new SqlParameter("@PASSWORD", SqlDbType.VarChar, 12)).Value = oData.Password;
			bbsCommand.Parameters.Add(new SqlParameter("@USERIP", SqlDbType.VarChar, 20)).Value = oData.UserIP;
			bbsCommand.Parameters.Add(new SqlParameter("@FORMAT", SqlDbType.TinyInt, 1)).Value = oData.Format;
			bbsCommand.Parameters.Add(new SqlParameter("@UseAvatar", SqlDbType.Bit)).Value = oData.UseAvatar;
			bbsCommand.Parameters.Add(new SqlParameter("@AvatarExpression", SqlDbType.TinyInt, 1)).Value = oData.AvatarExpression;

			bbsCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			int fileCount = 0;
			//   ϱ ̴.
			for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
			{
				HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
				String strFileName = Path.GetFileName(_postedFile.FileName);
				if (strFileName != "") fileCount++;
			}
			
			string sqlFileCount = "select count(*) from " + tableName + "Files where blfPID=" + oData.ID.ToString();
			SqlCommand bbsFileCountCommand = new SqlCommand(sqlFileCount, myConnection);

			myConnection.Open();
			SqlDataReader bfDr = bbsFileCountCommand.ExecuteReader();
			bfDr.Read();
			fileCount += bfDr.GetInt32(0);
			bfDr.Close();
			bbsCommand.Parameters.Add(new SqlParameter("@FILECOUNT", SqlDbType.TinyInt, 1)).Value = fileCount;

			string sqlDeleteFile = "delete from " + tableName + "Files where blfPID=@ID";
			string sqlInsertFile = "insert into " + tableName + "Files (blfPID,blfFileName,blfSize,blfContent) ";
			sqlInsertFile += "VALUES (@ID, @FileName, @Size, @Content)";
			
			SqlCommand bbsFileDeleteCommand = new SqlCommand(sqlDeleteFile, myConnection);
			SqlCommand bbsFileInsertCommand = new SqlCommand(sqlInsertFile, myConnection);

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			bbsCommand.Transaction = stTrans;
			bbsFileInsertCommand.Transaction = stTrans;
			bbsFileDeleteCommand.Transaction = stTrans;

			try
			{
				bbsCommand.ExecuteNonQuery();
				if (!bPreserve)
				{// ϵ .
					bbsFileDeleteCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = oData.ID;
					bbsFileDeleteCommand.ExecuteNonQuery();
				}

				for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ )
				{
					HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
					String strFileName = Path.GetFileName(_postedFile.FileName);

					if (strFileName == "") continue;

					int intSize = _postedFile.ContentLength;
					System.Byte[] FileByteArray = new System.Byte[intSize];
					Stream StreamObj = _postedFile.InputStream;
					StreamObj.Read(FileByteArray,0,intSize);

					bbsFileInsertCommand.Parameters.Clear();
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = oData.ID;
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.BigInt)).Value = intSize;
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@Content", SqlDbType.Image)).Value = FileByteArray;

					bbsFileInsertCommand.ExecuteNonQuery();
				}
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}
		}

		public int InsertReply(string tableName, BoardLactureData oData, HttpFileCollection UploadFiles)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand bbsCommand = new SqlCommand("SP_LACTURE_INSERT_REPLY_ROW", myConnection);

			bbsCommand.CommandType = CommandType.StoredProcedure;
			bbsCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			bbsCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = oData.ID;
			//bbsCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;
			bbsCommand.Parameters.Add(new SqlParameter("@SUBJECT", SqlDbType.VarChar, 100)).Value = oData.Subject;
			bbsCommand.Parameters.Add(new SqlParameter("@WRITER", SqlDbType.VarChar, 20)).Value = oData.Writer;
			bbsCommand.Parameters.Add(new SqlParameter("@EMAIL", SqlDbType.VarChar, 40)).Value = oData.Email;
			bbsCommand.Parameters.Add(new SqlParameter("@CONTENT", SqlDbType.Text)).Value = oData.Content;
			bbsCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 20)).Value = oData.UserID;
			bbsCommand.Parameters.Add(new SqlParameter("@USERIP", SqlDbType.VarChar, 20)).Value = oData.UserIP;
			bbsCommand.Parameters.Add(new SqlParameter("@FORMAT", SqlDbType.TinyInt, 1)).Value = oData.Format;
			bbsCommand.Parameters.Add(new SqlParameter("@UseAvatar", SqlDbType.Bit)).Value = oData.UseAvatar;
			bbsCommand.Parameters.Add(new SqlParameter("@AvatarExpression", SqlDbType.TinyInt, 1)).Value = oData.AvatarExpression;

			bbsCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;
			int fileCount = 0;
			//   ϱ ̴.
			for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
			{
				HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
				String strFileName = Path.GetFileName(_postedFile.FileName);
				if (strFileName != "") fileCount++;
			}
			bbsCommand.Parameters.Add(new SqlParameter("@FILECOUNT", SqlDbType.TinyInt, 1)).Value = fileCount;

			myConnection.Open();

			string sqlInsertFile = "insert into " + tableName + "Files (blfPID,blfFileName,blfSize,blfContent) ";
			sqlInsertFile += "VALUES (@ID, @FileName, @Size, @Content)";

			SqlCommand bbsFileCommand = new SqlCommand(sqlInsertFile, myConnection);

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			bbsCommand.Transaction = stTrans;
			bbsFileCommand.Transaction = stTrans;

			try
			{
				bbsCommand.ExecuteNonQuery();

				for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
				{
					HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
					String strFileName = Path.GetFileName(_postedFile.FileName);

					if (strFileName == "") continue;

					int intSize = _postedFile.ContentLength;
					System.Byte[] FileByteArray = new System.Byte[intSize];
					Stream StreamObj = _postedFile.InputStream;
					StreamObj.Read(FileByteArray,0,intSize);

					bbsFileCommand.Parameters.Clear();
					bbsFileCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = Convert.ToInt32(bbsCommand.Parameters["RETURN_VALUE"].Value);
					bbsFileCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.BigInt)).Value = intSize;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Content", SqlDbType.Image)).Value = FileByteArray;

					bbsFileCommand.ExecuteNonQuery();
				}
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}
			return Convert.ToInt32(bbsCommand.Parameters["RETURN_VALUE"].Value);
		}

		public int DeleteOne(string tableName, int intID, int intGroupID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_LACTURE_BOARD_DELETE_ONE", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			myCommand.Parameters.Add(new SqlParameter("@FeedID", SqlDbType.Int, 4)).Value = intID;
			myCommand.Parameters.Add(new SqlParameter("@FeedGroupID", SqlDbType.Int, 4)).Value = intGroupID;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			string sqlDeleteFile = "delete from " + tableName + "Files where blfPID=@ID";

			SqlCommand bbsFileDeleteCommand = new SqlCommand(sqlDeleteFile, myConnection);

			bbsFileDeleteCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = intID;
			
			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			myCommand.Transaction = stTrans;
			bbsFileDeleteCommand.Transaction = stTrans;

			int ret = -1;
			try
			{
				myCommand.ExecuteNonQuery();
				ret = Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value);
				if (ret == -1)
				{
					myConnection.Close();
					return -1; //  ڵ尡 ִ.
				}

				// ϵ .
				bbsFileDeleteCommand.ExecuteNonQuery();
				
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
				ret = -2; //db 
			}
			finally
			{
				myConnection.Close();
			}

			return ret;
		}

		public void IncVisted(string tableName, int intID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_LACTURE_INCREASE_VISTED", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.BigInt)).Value = intID;
			myCommand.Parameters.Add(new SqlParameter("@TableName", SqlDbType.NVarChar, 50)).Value = tableName;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public void SaveFragBoardSetting(int moduleId, int bbsId, 
			byte fragBoardType, bool openWindowAtStart)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_LACTURE_SAVE_FRAG_BOARD_SETTING", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@moduleId", SqlDbType.Int)).Value = moduleId;
			myCommand.Parameters.Add(new SqlParameter("@bbsId", SqlDbType.Int)).Value = bbsId;
			myCommand.Parameters.Add(new SqlParameter("@fragBoardType", SqlDbType.TinyInt)).Value = fragBoardType;
			myCommand.Parameters.Add(new SqlParameter("@openWindowAtStart", SqlDbType.Bit)).Value = openWindowAtStart;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public void RemoveFragBoardSetting(int moduleId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_LACTURE_DELETE_FRAG_BOARD_SETTING", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@moduleId", SqlDbType.Int)).Value = moduleId;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public SqlDataReader GetFragBoardSetting(int moduleId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_LACTURE_GET_FRAG_BOARD_SETTING", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@ModuleID", SqlDbType.Int)).Value = moduleId;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}
	}
}
