/*
 * 2004 2 20 
 * */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.Shop.Admin
{
	/// <summary>
	/// ProductOptManage   Դϴ.
	/// </summary>
	public class ProductOptManage : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList drpdnlstSelectOption;
		protected System.Web.UI.WebControls.DataGrid datgrdOptionDef;
		protected System.Web.UI.WebControls.TextBox txtText;
		protected System.Web.UI.WebControls.Button btnUp;
		protected System.Web.UI.WebControls.Button btnDown;
		protected System.Web.UI.WebControls.Button btnAddOption;

		private int _optionTypeId;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			_optionTypeId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["optId"], -1);
			if (!IsPostBack)
			{
				PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
				drpdnlstSelectOption.DataSource = db.GetProductOptionList();
				drpdnlstSelectOption.DataTextField = "Subject";
				drpdnlstSelectOption.DataValueField = "ID";
				drpdnlstSelectOption.DataBind();

				drpdnlstSelectOption.Items.Insert(0, new ListItem("--- ϼ ---", "0"));
			}

			if (_optionTypeId != -1)
			{
				foreach (ListItem item in drpdnlstSelectOption.Items)
					if (Convert.ToInt32(item.Value) == _optionTypeId)
					{
						item.Selected = true;
						break;
					}
			}
		}

		private void BindData()
		{
			int optionId = (int)this.ViewState["optionId"];

			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("ID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Text", typeof(string)));
			dt.Columns.Add(new DataColumn("Value", typeof(string)));

			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			SqlDataReader sdr = db.GetProductOptionDefList(optionId);

			while (sdr.Read())
			{
				dr = dt.NewRow();

				dr[0] = sdr["ID"];
				dr[1] = sdr["Text"];
				dr[2] = sdr["Value"];


				dt.Rows.Add(dr);
			}
			sdr.Close();

			DataView dv = new DataView(dt);

			datgrdOptionDef.DataSource = dv;
			datgrdOptionDef.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.drpdnlstSelectOption.SelectedIndexChanged += new System.EventHandler(this.drpdnlstSelectOption_SelectedIndexChanged);
			this.btnUp.Click += new System.EventHandler(this.btnUp_Click);
			this.btnDown.Click += new System.EventHandler(this.btnDown_Click);
			this.datgrdOptionDef.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdOptionDef_CancelCommand);
			this.datgrdOptionDef.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdOptionDef_UpdateCommand);
			this.datgrdOptionDef.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdOptionDef_DeleteCommand);
			this.datgrdOptionDef.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdOptionDef_ItemDataBound);
			this.datgrdOptionDef.SelectedIndexChanged += new System.EventHandler(this.datgrdOptionDef_SelectedIndexChanged);
			this.btnAddOption.Click += new System.EventHandler(this.btnAddoption_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void drpdnlstSelectOption_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (drpdnlstSelectOption.Items[0].Value == "0")
			{
				drpdnlstSelectOption.Items.RemoveAt(0);
				drpdnlstSelectOption.SelectedIndex--;
				btnAddOption.Enabled = true;
				btnDown.Enabled = true;
				btnUp.Enabled = true;
			}

			int optId = Convert.ToInt32(drpdnlstSelectOption.SelectedItem.Value);
			this.ViewState["optionId"] = optId;
			BindData();
		}

		private void datgrdOptionDef_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			((DataGrid)sender).EditItemIndex = ((DataGrid)sender).SelectedIndex;
			BindData();
		}

		private void btnAddoption_Click(object sender, System.EventArgs e)
		{
			string text = txtText.Text;
			int optionId = (int)this.ViewState["optionId"];
			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			db.AddProductOptDef(optionId, text);
			BindData();
			txtText.Text = "";
		}

		private void datgrdOptionDef_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.EditItem)
			{
				DataRowView drv = (DataRowView)e.Item.DataItem;

				TextBox txtSelText = (TextBox)e.Item.Cells[1].FindControl("txtSelText");
				txtSelText.Text = drv["Text"].ToString();
				TextBox txtSelValue = (TextBox)e.Item.Cells[1].FindControl("txtSelValue");
				txtSelValue.Text = drv["Value"].ToString();
			}
		}

		private void datgrdOptionDef_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int id = Convert.ToInt32(e.Item.Cells[0].Text);

			TextBox txtSelText = (TextBox)e.Item.Cells[1].FindControl("txtSelText");
			TextBox txtSelValue = (TextBox)e.Item.Cells[1].FindControl("txtSelValue");

			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			db.UpdateProductOptDef(id, txtSelText.Text);
			((DataGrid)source).EditItemIndex = -1;
			((DataGrid)source).SelectedIndex = -1;
			BindData();
		}

		private void datgrdOptionDef_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = -1;
			((DataGrid)source).SelectedIndex = -1;
			BindData();
		}

		private void datgrdOptionDef_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if (((DataGrid)source).SelectedIndex != -1)
			{
				DataRowView drv = (DataRowView)e.Item.DataItem;
				PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
				db.DeleteProductOptDef((int)drv["ID"]);
				((DataGrid)source).EditItemIndex = -1;
				((DataGrid)source).SelectedIndex = -1;
				BindData();
			}
		}

		private void btnUp_Click(object sender, System.EventArgs e)
		{
			//õ ȾҰų(-1) ù°(0) õǾ  ʴ´.
			if (datgrdOptionDef.SelectedIndex > 0)
			{
				int optionId = (int)this.ViewState["optionId"];

				DataTable dt = new DataTable();
				DataRow dr;

				dt.Columns.Add(new DataColumn("ID", typeof(Int32)));
				dt.Columns.Add(new DataColumn("Inc3Order", typeof(int)));

				PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
				SqlDataReader sdr = db.GetProductOptionDefList(optionId);

				int sortOrder = 1;

				while (sdr.Read())
				{
					dr = dt.NewRow();

					dr[0] = sdr["ID"];
					dr[1] = sortOrder;
					sortOrder += 2;

					dt.Rows.Add(dr);
				}

				DataView dv = new DataView(dt);
				dv[datgrdOptionDef.SelectedIndex]["Inc3Order"] = (int)dv[datgrdOptionDef.SelectedIndex]["Inc3Order"] - 3; 
				dv.Sort = "Inc3Order";
				int orderNo = 1;
				foreach (DataRowView item in dv)
					db.UpdateProductOptDefOrder((int)item["ID"], orderNo++);

				datgrdOptionDef.SelectedIndex--;
				datgrdOptionDef.EditItemIndex = datgrdOptionDef.SelectedIndex;
				BindData();
			}
		}

		private void btnDown_Click(object sender, System.EventArgs e)
		{
			//õ ȾҰų(-1) (0) õǾ  ʴ´.
			if (datgrdOptionDef.SelectedIndex != -1 && datgrdOptionDef.SelectedIndex < datgrdOptionDef.Items.Count-1)
			{
				int optionId = (int)this.ViewState["optionId"];

				DataTable dt = new DataTable();
				DataRow dr;

				dt.Columns.Add(new DataColumn("ID", typeof(Int32)));
				dt.Columns.Add(new DataColumn("Inc3Order", typeof(int)));

				PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
				SqlDataReader sdr = db.GetProductOptionDefList(optionId);

				int sortOrder = 1;

				while (sdr.Read())
				{
					dr = dt.NewRow();

					dr[0] = sdr["ID"];
					dr[1] = sortOrder;
					sortOrder += 2;

					dt.Rows.Add(dr);
				}

				DataView dv = new DataView(dt);
				dv[datgrdOptionDef.SelectedIndex]["Inc3Order"] = (int)dv[datgrdOptionDef.SelectedIndex]["Inc3Order"] + 3; 
				dv.Sort = "Inc3Order";
				int orderNo = 1;
				foreach (DataRowView item in dv)
					db.UpdateProductOptDefOrder((int)item["ID"], orderNo++);

				datgrdOptionDef.SelectedIndex++;
				datgrdOptionDef.EditItemIndex = datgrdOptionDef.SelectedIndex;
				BindData();
			}		
		}
	}
}
