/*
 * 2004 2 20 
 * */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.Shop.Admin
{
	/// <summary>
	/// ShopProductManage   Դϴ.
	/// </summary>
	public class ShopProductManage : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList drpdnlstTopCategory;
		protected System.Web.UI.WebControls.DropDownList drpdnlstIndexCategory;
		protected System.Web.UI.WebControls.HyperLink hyplnkNewWrite;
		protected System.Web.UI.WebControls.LinkButton lnkbtnModify;
		protected System.Web.UI.WebControls.DataGrid datgrdProdList;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!this.IsPostBack)
			{
				PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
				drpdnlstTopCategory.DataSource = db.GetCategoryTopList();
				drpdnlstTopCategory.DataTextField = "Name";
				drpdnlstTopCategory.DataValueField = "ID";
				drpdnlstTopCategory.DataBind();

				int topId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["topId"], -1);
				int indexId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["indexId"], -1);
				if (topId != -1 && indexId != -1)
				{
					foreach (ListItem item in drpdnlstTopCategory.Items)
						if (Convert.ToInt32(item.Value) == topId)
						{
							item.Selected = true;
							break;
						}

					drpdnlstIndexCategory.DataSource = db.GetCategoryIndexList(topId);
					drpdnlstIndexCategory.DataTextField = "Name";
					drpdnlstIndexCategory.DataValueField = "ID";
					drpdnlstIndexCategory.DataBind();

					foreach (ListItem item in drpdnlstIndexCategory.Items)
						if (Convert.ToInt32(item.Value) == indexId)
						{
							item.Selected = true;
							break;
						}

					this.ViewState["IndexID"] = indexId;
					BindDataGrid();

					hyplnkNewWrite.Enabled = true;
					hyplnkNewWrite.NavigateUrl = "WriteProduct.aspx?bypass=true&indexId=" + 
						drpdnlstIndexCategory.SelectedItem.Value + 
						"&topId=" + drpdnlstTopCategory.SelectedItem.Value;
				}
				else
					drpdnlstTopCategory.Items.Insert(0, new ListItem("--- ϼ ---", "0"));
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.drpdnlstTopCategory.SelectedIndexChanged += new System.EventHandler(this.drpdnlstTopCategory_SelectedIndexChanged);
			this.drpdnlstIndexCategory.SelectedIndexChanged += new System.EventHandler(this.drpdnlstIndexCategory_SelectedIndexChanged);
			this.datgrdProdList.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.datgrdProdList_PageIndexChanged);
			this.datgrdProdList.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdProdList_CancelCommand);
			this.datgrdProdList.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdProdList_EditCommand);
			this.datgrdProdList.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdProdList_UpdateCommand);
			this.datgrdProdList.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdProdList_DeleteCommand);
			this.datgrdProdList.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdProdList_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void BindDataGrid()
		{
			int indexId = (int)this.ViewState["IndexID"];
			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			//datgrdProdList.DataSource = db.GetProductListByIndexId(indexId);
			datgrdProdList.DataSource = db.GetProductListByIndexId(indexId).Tables[0].DefaultView;
			datgrdProdList.DataBind();
		}

		private void drpdnlstTopCategory_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (drpdnlstTopCategory.Items[0].Value == "0")
			{
				drpdnlstTopCategory.Items.RemoveAt(0);
				drpdnlstTopCategory.SelectedIndex--;
			}
			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			drpdnlstIndexCategory.DataSource = db.GetCategoryIndexList(Convert.ToInt32(drpdnlstTopCategory.SelectedItem.Value));
			drpdnlstIndexCategory.DataTextField = "Name";
			drpdnlstIndexCategory.DataValueField = "ID";
			drpdnlstIndexCategory.DataBind();
			drpdnlstIndexCategory.Items.Insert(0, new ListItem("--- ϼ ---", "0"));

			hyplnkNewWrite.Enabled = false;
		}

		private void drpdnlstIndexCategory_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (drpdnlstIndexCategory.Items[0].Value == "0")
			{
				drpdnlstIndexCategory.Items.RemoveAt(0);
				drpdnlstIndexCategory.SelectedIndex--;
			}

			this.ViewState["IndexID"] = Convert.ToInt32(drpdnlstIndexCategory.SelectedItem.Value);
			BindDataGrid();

			hyplnkNewWrite.Enabled = true;
			hyplnkNewWrite.NavigateUrl = "WriteProduct.aspx?bypass=true&indexId=" + 
						drpdnlstIndexCategory.SelectedItem.Value + 
						"&topId=" + drpdnlstTopCategory.SelectedItem.Value;
		}

		protected string GetImageName(DataRowView drv)
		//protected string GetImageName(IDataRecord drv)
		{
			string strNum = "0000" + drv["ID"].ToString();
			strNum = strNum.Substring(strNum.Length-5);

			return "ProdImgS_" + strNum + ".jpg";
		}

		private void datgrdProdList_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = e.Item.ItemIndex;
			BindDataGrid();
		}

		private void datgrdProdList_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			// ޼ҵ忡 ƷͰ    .
			//int id = (int)((IDataRecord)e.Item.DataItem)["ID"];
			//(((DateGridItem)datgrdProdList.Items[0]).DataItem);

			Label lblProdID = (Label)e.Item.Cells[0].FindControl("lblProdID");
			int id = Convert.ToInt32(lblProdID.Text);

			TextBox txtName = (TextBox)e.Item.Cells[0].FindControl("txtName");
			TextBox txtPrice = (TextBox)e.Item.Cells[0].FindControl("txtPrice");
			TextBox txtDCPercent = (TextBox)e.Item.Cells[0].FindControl("txtDCPercent");
			TextBox txtDescription = (TextBox)e.Item.Cells[0].FindControl("txtDescription");
			CheckBox chkboxAbsence = (CheckBox)e.Item.Cells[0].FindControl("chkboxAbsence");
			HtmlInputFile fileImageS = (HtmlInputFile)e.Item.Cells[0].FindControl("fileImageS");
			HtmlInputFile fileImageM = (HtmlInputFile)e.Item.Cells[0].FindControl("fileImageM");
			HtmlInputFile fileImageL = (HtmlInputFile)e.Item.Cells[0].FindControl("fileImageL");
			TextBox txtWeight = (TextBox)e.Item.Cells[0].FindControl("txtWeight");
			TextBox txtStone = (TextBox)e.Item.Cells[0].FindControl("txtStone");
			DropDownList drpdnlstBrand = (DropDownList)e.Item.Cells[0].FindControl("drpdnlstBrand");

			int price;
			int dcPercent;
			try
			{
				price = Convert.ToInt32(txtPrice.Text);
				dcPercent = Convert.ToInt32(txtDCPercent.Text);
			}
			catch
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ԷϽ  ùٸ Ƚϴ.");
				return;
			}

			if (dcPercent > 100)
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ԷϽ  ùٸ Ƚϴ.");
				return;
			}
			
			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			int result = db.UpdateProduct(id, txtName.Text, txtDescription.Text, price, dcPercent, 
				chkboxAbsence.Checked, fileImageS.PostedFile, 
				fileImageM.PostedFile, fileImageL.PostedFile,
				Convert.ToInt32(drpdnlstBrand.SelectedItem.Value), 
				Convert.ToInt32(txtWeight.Text),txtStone.Text
				);

			if (result == -2)
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("JPEG ϸ ε  ֽϴ.");
				return;
			}
			else if (result == -1)
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" !");
				return;
			}


			((DataGrid)source).EditItemIndex = -1;
			BindDataGrid();
		}

		private void datgrdProdList_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = -1;
			BindDataGrid();
		}

		private void datgrdProdList_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			//int id = (int)((IDataRecord)e.Item.DataItem)["ID"];
			int id = (int)((DataRowView)e.Item.DataItem)["ID"];

			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			db.DeleteIProd(id);
			((DataGrid)source).EditItemIndex = -1;
			BindDataGrid();
		}

		private void datgrdProdList_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.EditItem)
			{

				MyWebLibs.Utilities.CommonMethods.GetForm(this).Enctype = "multipart/form-data";

				//int id = (int)((IDataRecord)e.Item.DataItem)["ID"];
				int id = (int)((DataRowView)e.Item.DataItem)["ID"];
				Label lblProdID = (Label)e.Item.Cells[0].FindControl("lblProdID");
				lblProdID.Text = id.ToString();

				PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
				SqlDataReader dr = db.GetProduct(id);
				dr.Read();

				TextBox txtName = (TextBox)e.Item.Cells[0].FindControl("txtName");
				txtName.Text = dr["Name"].ToString();

				TextBox txtPrice = (TextBox)e.Item.Cells[0].FindControl("txtPrice");
				txtPrice.Text = dr["Price"].ToString();
				TextBox txtDCPercent = (TextBox)e.Item.Cells[0].FindControl("txtDCPercent");
				txtDCPercent.Text = dr["DiscountPercent"].ToString();

				CheckBox chkboxAbsence = (CheckBox)e.Item.Cells[0].FindControl("chkboxAbsence");
				chkboxAbsence.Checked = Convert.ToBoolean(dr["Absence"]);

				TextBox txtDescription = (TextBox)e.Item.Cells[0].FindControl("txtDescription");
				txtDescription.Text = dr["Description"].ToString();

				TextBox txtWeight = (TextBox)e.Item.Cells[0].FindControl("txtWeight");
				txtWeight.Text = dr["Weight"].ToString();

				TextBox txtStone = (TextBox)e.Item.Cells[0].FindControl("txtStone");
				txtStone.Text = dr["Stone"].ToString();
				
				DropDownList drpdnlstBrand = (DropDownList)e.Item.Cells[0].FindControl("drpdnlstBrand");

				drpdnlstBrand.DataSource = db.GetBrandList();
				drpdnlstBrand.DataTextField = "Name";
				drpdnlstBrand.DataValueField = "ID";
				drpdnlstBrand.DataBind();
				string brandId = dr["BrandID"].ToString();
				foreach(ListItem item in drpdnlstBrand.Items)
					if (item.Value == brandId)
					{
						item.Selected = true;
						break;
					}
				dr.Close();
			}
		}

		private void datgrdProdList_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			datgrdProdList.CurrentPageIndex = e.NewPageIndex;
			BindDataGrid();
		}

	}
}
